Welcome

Welcome to Beyond Compare 3

Beyond Compare is a utility for comparing files and folders. It can help you find and reconcile differences in source code, folders, images and data, even if your files are contained in zip archives or on FTP sites. It can synchronize your folders, and validate your copies.

Beyond Compare seamlessly coordinates the entire comparison job, from the folder structure down to individual differences in files. Specialized file viewers communicate difference info back to the folder session, helping you quickly concentrate on important differences. Beyond Compare remembers your various sessions so that you can come back to the same comparison job time after time.

This document describes both the Standard vs Pro Editions of Beyond Compare. Features that are only available in the Pro edition are indicated by this green icon:

Beyond Compare is available for both Windows and Linux. Items in this document that refer to a specific platform are indicated by these icons:


What's New

Version 3 is a fairly complete rewrite of Beyond Compare. Like the transition from version 1 to version 2, we took the opportunity to rethink the user interface, redesign some of the internal fundamentals, and add significant new functionality.

Here are some of the significant new features in Beyond Compare 3. Items flagged with [image] are only available in the Pro edition.

Expanded Session concept

· Any comparison can be saved as a session, not just folder comparisons
· Plug-ins have been replaced by built-in session types
· Saved sessions can be organized in folders
· New comparisons are now automatically saved as sessions

Fully unicode enabled

· Unicode filenames are now supported, in addition to Unicode file content

Interface Improvements

· Tabbed interface for session views
· Handy "home" view for launching and managing sessions
· Layout of open sessions can be saved, restored
· Built-in "check for updates" feature

Folder Compare features

· Folder icon colors now match your preferences
· Multiple operations can be queued
· File actions now respect filters by default
· Dedicated Folder Sync session
· Touch and Attributes commands can now recurse through subfolders
· Attributes command now supports Unix attributes
· New Ignored command flags mismatched file as okay
· New Move to Folder command
· Flatten folders lets you compare differing folder structures
· Ability to override which files are aligned

Text Compare features

· Full in-pane editor with dynamic re-comparisons
· Syntax highlighting
· Adaptive gutter buttons for copying sections
· Unlimited undo after save
· Grammar-based comparison rules
· Independent file formats for each side of the comparison
· New Ignored command flags mismatched sections as okay
· Multiple bookmarks
· Hex display option for line details
· 3-way text merge
· Ability to treat specific text on one side as unimportant when compared to specific text on the other side

Improved FTP support

· FTP profiles, selectable per session
· Multiple simultaneous connections
· Built-in support for secure FTP protocols (SFTP and FTP over SSL)


Standard vs Pro Editions

The Standard edition of Beyond Compare 3 is a powerful full-featured comparison tool, not a stripped-down "lite" version. The Standard edition brings forward the functionality in Beyond Compare 2, and adds full-screen editing, full Unicode support, syntax highlighting and much more.

However, the Pro edition adds these advanced functions:

3-way text merging

Compares independent changes against a common ancestor to create new merged content.

Text replacements

Specifies text as unimportant if it is changed to a specific value on the other side. For example, you can make apple found on the left when compared to orange on the right an unimportant difference.

Folder Compare alignment overrides

Overrides how files are aligned in a Folder Compare session. For example, you could compare your .gif files on one side with .png files of the same name on the other side.

Source control integration

Adds commands for checking files in or out of SCC-compliant version control systems.

SFTP support

Rather than relying on third-party solutions, Beyond Compare 3 Pro has integrated support for secure FTP protocols (SFTP and FTP over SSL).

Registry Compare

Compares live registries, both local and remote, as well as registry files.

Note The trial download of Beyond Compare actually contains both Standard and Pro editions. You can disable Pro mode in the Help > About dialog in order to limit your trial to Standard functionality.

Your license key will unlock the appropriate edition for permanent use. If you choose the Standard Edition license, you can upgrade later to Pro for the difference in price.


Using Beyond Compare

Beyond Compare handles a wide variety of comparison tasks. It has specialized viewers for different kinds of files and different approaches to reconciling differences.

Each comparison task is called a Session. Sessions can be individualized, named and reused. Many of Beyond Compare's settings are managed and stored by session rather than as program-wide options, to give you greater flexibility. You can save different Folder Compare sessions with quite different settings, to accommodate differing tasks.

A Child Session is a file session that originated from a folder session.

Sessions can be opened in separate windows, or as multiple tabs on a single window. We refer to open sessions as Views. You can have multiple windows open, each with multiple tabs. You can drag a tab from one window to another, or right-click a tab and select Tear Off from the context menu to move that tab onto its own window. (See Tab Options.)

You can save currently open sessions as a Workspace, and load them again later with the same configuration of windows and tabs. (See Managing Workspaces.)

The session settings that control how comparisons are performed are called Rules. Rules help you concentrate on important differences. Beyond Compare also maintains a list of file formats to specify how various types of files are to be handled. You can modify the built-in file formats or create your own.

This part of the documentation provides an overview of the various types of sessions and program concepts mentioned above.


Home View

The Home View

When you open a new window or tab, Beyond Compare displays the Home view:

Click to zoom

From the Home view, you can:

· Start a new comparison session of any type
· Select from one of your previously saved sessions
· Select an auto-saved session
· Manage the settings for your saved sessions
· Edit the default settings to use for new sessions

You can also drag and drop files or folders from a file manager such as Windows Explorer onto this page to compare them. Drag and drop onto one of the Start new session buttons to start a session of that specific type.

To customize your Home view, select Options [image] from the Tools menu, then select General.


Managing Sessions

Beyond Compare automatically saves your most recent sessions so you can come back to them easily. If you want to retain a session indefinitely, you can save it with a descriptive name. You can also organize your named sessions within session folders.

The Session menu contains common commands for manipulating the current session. If you make a change to the parameters of a named session, you will be prompted to save it on exit.

Use the Home view to manage all your sessions in one place. You can select a saved session and edit its settings in the tabbed control at the right of the session tree. To rename or delete a session, right-click in the saved sessions tree and select the appropriate command.

A named session can be locked to guard against accidental modifications. Right-click a named session and select Lock from the context menu.

To change default session settings:

In the Home view's Saved sessions tree, under the Edit session defaults branch, select a session type. Edit the default settings in the tabbed control at the right of the tree.


Sharing Sessions

Multiple users can share read-only sessions by using a shared sessions file. From the Tools menu, choose Export Settings to create a .bcpkg settings package with any subset of your sessions.

To access a shared sessions file

1. From the Tools menu select Options [image].
2. On the General page, enter the location of the Shared sessions file.

Shared sessions will then appear as a new branch in the saved sessions tree:


Folder Compare Overview

A Folder Compare session compares two folder structures side-by-side, in a variation of the familiar Explorer style. The comparison may be of folders on your hard drive or network, but either side also may be an FTP site, a zip archive, or a snapshot taken earlier. All of these have a directory structure – folders and subfolders containing files – and Beyond Compare treats them equivalently.

Click to zoom

The Folder Compare view uses color to highlight the differences between the two sides. Select View > Legend to display a guide to the various folder icon color combinations. See Understanding the Display for details.

A typical Folder Compare strategy is to:

1. Define how to compare folder structures
2. Filter the view to show important differences
3. Reconcile the differences

You can click on a column header to sort by that column, or right-click the header to choose different columns to display.

See also

Folder Compare Commands

Folder Compare Settings

Folder View Options


Understanding the Folder Compare Display

The Folder Compare display uses color cues to highlight the differences between the two base folders. By default, the color meanings are:

Black | Match
Red | Newer or mismatch
Gray | Older
Blue | Orphan (does not exist on other side)

To change the default colors, select Options [image] from the Tools menu and under Folder Views select Compare Colors.

Files in the display

In the following example, the file on the right side is colored red to show that it is newer. The icon in the center column [image] shows that a content comparison has found differences.

The content comparison results can override the file colors. For example, the above line would change to all black if the content comparison returned an exact match. You can change this behavior by disabling the Override quick test results option on the Comparison tab of the session settings.

The center column shows the results of a content comparison, if any:

Binary match | The files are byte-by-byte the same.
Binary mismatch | At least one byte is different between the files.
Match | Although the files have some binary difference, a rules-based comparison found them to match.
Similar | A rules-based comparison found only unimportant differences.
Mismatch | A rules-based comparison found important differences.

Some file types, such as zip archives, can be a container for other files. Beyond Compare can handle these like regular folders. The following example shows our compiled help file with a newer version on the right side. Notice the special "zipper" icon.

You can double-click the file to expand it and compare each of the contained files.

Folders in the display

Folders are colored to give you hints about their contents. For instance, the comparison below lets you know that the folders contain at least one file that is newer on the right (red), and that both sides have at least one orphaned file (blue).

Folders may appear hollow when you first start the comparison. This happens when the background scanning process has not yet completed those folders. They will change color when the process is finished.

A folder will be yellow if auto-scan is turned off and you haven't opened the folder yet. Once you manually open the folder (and possibly its subfolders) it will be colored appropriately.

Folder icons will include a small arrow glyph if the folder is a junction point or symbolic link. Folder icons will include a small red "X" glyph if there was an error trying to open the folder. The following example shows a folder with both conditions.


How to Compare Folders

There are several ways to compare folders and files.

If you want a quick look at what has changed between two folders, it might be sufficient to just look at the dates and sizes of the files. If you are validating a CD copy, then a byte-by-byte comparison of every file is important. If you are comparing versions of source code, perhaps you want to consider only significant changes and ignore differences in whitespace or comments.

Session settings define how, overall, a Folder Compare session should compare folders when the session is loaded. Comparison criteria include file timestamps, sizes, attributes and contents. Once the session is loaded, you can selectively recompare files with the Compare Contents [image] command or by opening the files in a file session.

Generally, these criteria are used to compare files, and not folders directly. For instance, a folder's timestamp does not affect the comparison. A folder is classified as "newer" if it contains newer files. Folders are compared by aggregating the comparisons of files within them.

Certain facts about a file can be determined quickly while others take some time. The Comparison tab of the Session Settings dialog is organized into Quick tests and Requires opening files. File systems typically provide fast access to file names, sizes, and timestamps (the date and time last modified). But to get the CRC of a file, the entire file will need to be read. Keep this in mind when selecting folder comparison criteria. See also Content Comparisons.

The display aligns files and subfolders of the same name, left and right. You can modify the alignment by defining alignment overrides in the session's Rules [image]. You can also align files regardless of what subfolder they are in by using the View > Ignore Folder Structure command.


Filtering the Folder Compare View

There are two overall type of filters you can use to control a Folder Compare's scope: File filters that include or exclude files based on their name or attributes, and display filters that show or hide lines of the comparison based on comparison status.

For instance, you can set the display filter to Show Left Newer to display only those files that are newer on the left side of the comparison. Or you can set a file filter to exclude *.bak files if you don't want to see or manipulate them.

By default, commands that act on a selected folder's contents (such as Copy, Move, Delete, etc.) will respect the current filters. That is, if the selection includes a folder, the folder's filtered-out contents are skipped. (Note that this behavior has changed from Beyond Compare 2.) To change this default behavior, go to Tools > Options > Folder Views > Confirmations and enable Include hidden items by default. In either case, action dialogs allow you to override the default behavior on a case-by-case basis.

On the View menu, choose Suppress Filters [image] to temporarily suppress file filters and display filters. Files and folders that were hidden will appear colored teal (blue-green) and can be processed.

File Filters

You can specify the type of files you want to include in (or exclude from) the session. For instance, if you are comparing Delphi projects you could include file types such as *.pas, *.dfm, and *.dpr. Or, you could include all files except *.dcu and *.~* by excluding these file types.

To specify a simple "include these types" filter, use the Filters field on the toolbar. Enter the file types separated by semicolons, or use the dropdown to select from presets. Include a minus sign (-) in front of files to be excluded.

In addition to these simple wildcard filters, you can specify more complex filters that include or exclude files or folders by name. From the Session menu, select Session Settings [image], and in the dialog select the Name Filters tab. Or, simply click the File Filters [image] icon on the toolbar. See also Folder Compare Name Filters.

Files can also be filtered based on their modified date, size, file attributes or text content. Select the Other Filters tab in the Session Settings dialog. (Folders are not directly filtered based on their attributes, but are affected by the filtering of their contents.) See also Folder Compare Other Filters.

Display Filters

Display filters limit the view to certain comparison results. The comparison results are determined by the session's comparison rules. For instance, you can pick Show Differences [image] to remove all the matching files so that you can concentrate on the mismatches.

See also Display Filters.

Folder Display Filters

Special folder display filters control when folders appear, other than to hold visible files.

Always Show Folders [image] causes all folders to appear (unless they have been explicitly excluded by file filters), regardless of the other display filter selection.

Compare Files and Folder Structure [image] causes folders to respect the display filters. For example, if the main display filter is Show All then all folders appear. If it is Show Orphans, only orphan folders and folders that contain orphan files are shown.

Only Compare Files [image] suppresses all empty folders, both truly empty folders and folders whose entire contents are hidden by other display or file filters.

Ignore Folder Structure [image] hides the folder tree and aligns files regardless of what subfolder they are in.


Reconciling Differences

A Folder Compare session provides Actions, such as Copy, Move, Delete and Synchronize, to help you reconcile differences on the folder level. It also is a platform for spawning file views to understand and reconcile differences within files.

Actions generally require a selection. You can select specific files or folders from either or both sides and then perform some action on them. (If you want to synchronize the entire contents of the base folders, consider using a Folder Sync session instead.)

To select items in the Folder Compare view:

Click on an item on either side of the display to select it. You can click in the center column to select both sides at once. Hold down the Ctrl key and click to add items to your selection. To select a range of items, press the mouse button over the first, swipe to the last, and release the button. If your swipe crosses the middle column, entries on both sides will be selected.

To select all items on one side:

Pick Select All [image] (or Select All Files [image]) from the Edit menu. Hold down the Shift key and press the left arrow key to limit the selection to the left side. Press the right arrow key instead to limit the selection to the right side.

To compare files with different names:

Click the first file, hold down the Ctrl key and click the second one, and then select Open. To use the keyboard instead, position on the first file and press the space bar, then position on the second one and press the space bar to Open.


Archive Files

Archives are files that contain other files, such as .zip. Beyond Compare displays them as folders, with a zipper icon, but by default treats them as files when copying or comparing them. Once you have expanded the archive by double clicking on it, the files within will be compared. Many of the formats support both reading and writing, so you can use all of the usual file operations on the files within the archives, including comparing the content, copying, renaming, etc.

These standard archive formats are supported

7-zip (*.7z;*.7z.001)

BZip (*.bz;*.bz2)

BZipped Tar (*.tbz;*.tbz2;*.tar.bz2)

Beyond Compare Snapshot (*.bcss;*.bcs)

Compiled HTML Help (*.chm)

Debian Packages (*.deb)

GZip (*.gz)

GZipped Tar (*.tgz;*.tar.gz)

Microsoft Cabinet (*.cab)

RAR (*.rar)

Red Hat Packages (*.rpm)

Tar (*.tar)

Zip (*.zip;*.jar;*.ear;*.war;*.bcpkg)

Beyond Compare Snapshots

These files are similar to other archives, but only include the file names, dates, and sizes, without including the file content itself. Since they are so small, you can save a snapshot of an entire hard drive and compare against it later.

Total Commander "Packer" Plug-ins

Beyond Compare can also use Total Commander "packer" plug-ins to support additional archive formats. For example, there are plug-ins to support ISO disc images (.iso) and Microsoft Installer Packages (.msi).

To add one of these third party plug-ins, go to Tools > Options > Folder Views, click Add Plug-in, and follow the instructions.


Folder Sync Overview

A Folder Sync session is a specialized folder session that synchronizes folders by copying or deleting files.

Click to zoom

Once you set up a Folder Sync session you can save it for future use.

Setting sync parameters

In the upper part of the view, specify the Left folder and Right folder involved. Either or both base folders may be on FTP sites. (You can use the Browse buttons to specify an FTP site.)

Select one of these standard sync methods from the drop-down control in the middle of the view:

Update Left

Copies newer and orphan files from right to left.

Update Right

Copies newer and orphan files from left to right.

Update Both

Copies newer and orphan files to the other side.

Mirror to Left

Replaces all different items on left, deletes any orphans on left, and copies any right side orphans to the left.

Mirror to Right

Replaces all different items on right, deletes any orphans on right, and copies any left side orphans to the right.

Click the Rules [image] button to define what constitutes a difference.

You can also specify Filters [image] to limit the scope of the sync.

Previewing the sync

Click the Accept [image] button if necessary to accept changes, and a preview of all copy and delete operations will appear in the lower part of the view.

You can double-click any file pair to examine the differences in detail. To skip individual operations, right-click the line and pick Exclude from the popup menu.

Starting the sync

Click Sync Now [image] to begin processing.

See also

Folder Sync Commands

Folder Sync Settings

Folder View Options


Text Compare Overview

A Text Compare session visually compares two text files, in a side-by-side or over-under layout. It helps you analyse and reconcile differences, with a variety of display, search, and editing functions available.

Click to zoom

In addition to files on your hard drive or network, you can specify files from an FTP site, from within a zip archive, or the content of a webpage. Example file specs:

C:\MyArchive.zip\MyFile.txt

/home/username/Desktop/MyFile

ftp://username@ftp.hostname.com/file.txt

http://www.scootersoftware.com/index.html

You can also compare against text on the clipboard by selecting Open Clipboard from the File menu.

The Text Compare view displays files in two editor panes that scroll together. Text is colored to highlight differences between the files. By default, the color scheme uses red to flag important differences (insertions, deletions, and changes) and blue for unimportant differences. The session's rules and file formats control how text is classified.

The display background is also colored to help you spot the differences. A light red background indicates an important difference somewhere on the line, while light-blue indicates an unimportant difference. The light red background takes precedence over the light blue. This makes it easy to find differences, even if they are horizontally scrolled out of view. You can adjust these colors to suit your preferences. (See File View Comparison Colors.)

On the left edge of the display is the optional thumbnail view. It represents each line of the comparison as a colored line, one pixel high. At a glance you can see the pattern of differences throughout the comparison. The white rectangle represents the main display's current view, and the small triangle represents the display's current line. Click on a line in the thumbnail to position the display at that location.

Below the main panes, the current line from each file is displayed using the entire width of the window. From the View menu, choose Text Details [image] for an editable text view, Hex Details [image] for a read-only hexadecimal view, or Aligned Details [image] for a read-only view of the character alignment.

See also

Text Compare Commands

Text Compare Settings

Text Format Settings

Text View Options


Editing Text

Each pane of the Text Compare view is a full-featured text editor. You can enter and edit text like any other text editor, although as you do the comparison is continually updated to reflect differences between the panes.

Line mode vs. character mode

The Full Edit [image] command toggles the editor between line mode and character mode. In line mode it works similarly to Beyond Compare 2, where editing occurs on a line-by-line basis, so selection, cut, copy, paste, delete, etc. all affect entire lines. While in line mode you can edit individual lines using the Text Details area. Line mode supports disjointed selections. In character mode the main panes support editing text. Selection and editing commands all affect individual characters or spans of characters. Character mode can only have a single, continuous selection.


Walking Through Differences

The Next Difference Section [image] and Previous Difference Section [image] commands help you step through all the differences in your files, and all your files with differences. In the Text Compare, click Next Difference Section to position at the next range of lines with differences or Previous Difference Section to go back to the previous range of lines with differences.

The arrow icons will either be disabled or change color from bright yellow to dull yellow to indicate that there are no more differences in that direction. To configure what happens when there are no more differences, see File View Next Difference Options.

In Text Compare sessions, the current file format controls whether Next and Previous are on a line-by-line basis or a section-by-section basis. To access the current file format from a Text Compare session, select Session > Session Settings > Importance and click the Edit Grammar button. Then, on the Text Format dialog's Misc tab, toggle Lines are independent.

You can use Next Difference and Previous Difference to position on individual differences in long lines with multiple differences.

To jump directly to the next files with differences in the associated folder view, from the Search menu select Next Difference Files [image], or Previous Difference Files [image].


Searching for Text

To search for text in a Text Compare session, select Find [image] from the Search menu. Type the text or a regular expression pattern in the Text to find edit, or click the dropdown [image] to select from a list of previous searches. There is also a separate dropdown [image] button with a list of common regular expression terms. Pick one from the list to insert it in the match edit.

Click Find to move the cursor to the next match. If the editor is in line mode, you can click Select All to select all the lines that contain a match.

The Find dialog options are:

Option | Meaning
Match character case | Only match text with the same character case (uppercase or lowercase).
Whole words only | Searching for apple will not match on apples, applesauce or snapple.
Regular expression | Interpret search text as a Perl-compatible regular expression.
Wrap search | When one end of the file is reached, continue searching at the other end.
Search up | Search for the first text to match that is before the cursor.
Sides | Select which side(s) of the comparison to search.

Mark the Close dialog automatically checkbox if you want the dialog to close when you click Find.

Select Find Next [image] or Find Previous [image] to continue searching for the same text.

To find and replace text, select Replace [image].


Text Merge Overview

A Text Merge session contains two or three non-editable source panes and an editable output pane. The left and right panes hold two versions of a file. Beyond Compare helps you combine changes from both versions into the output pane. The optional center pane holds an older version of the file, a common ancestor of the left and right versions.

Click to zoom

You can temporarily disable Center Pane [image] to give the left and right panes more room. You can also use the Detached Output Pane [image] to move the output into a separate window. If you have a second monitor, you can then move this window onto it.

The output content is constructed automatically as the comparison loads. You can manually edit the output, or use Take buttons to pull text from a specific source file, overriding the default merge.

It is important to note that any prior copy of the output file is ignored. If it existed before the merge session, or was changed during the session, the existing content will be lost if you save the merge session output.

See also

3-way Merge Concepts

Text Merge Commands

Text Merge Settings

Text Format Settings

Text View Options


Using Text Merge

Once Beyond Compare has completed the comparison it will show up to four panes: The left, center, and right panes at the top, with an output pane below it. If you include a center file Beyond Compare will be able to compare both files to it and mark changes as additions, modifications, or deletions on each specific side. Changes on the left are marked in blue and changes on the right are marked in purple. Overlapping changes are considered conflicts and are marked in red. (You can change the color scheme if you like.)

Conflicts

Any time there are different changes in the left and right side that are on the same lines or within two lines of each other those sections will be considered a conflict and will be colored red in the three input panes. The output will be considered a conflict. If the same change is made in both the left and right side it isn't considered a conflict.

Merging Data

You can navigate from difference to difference in both the input and output panes and the windows will stay synched up. When you are positioned on a difference you can use the Take Left [image], Take Center [image], and Take Right [image] commands to accept the changes from the left or right or keep the original from the center. The "Take" commands are available on the toolbar, in each edit's popup menu, and as buttons next to each section in the output pane. When it first loads, the output pane will have selected all non-conflicting changes automatically, and each change will be colored to match the pane it originally came from. While merging you can also edit the output pane directly, which will change the section to yellow. If you want to revert to one of the original inputs just use the "Take" command again.

Display Filters

When merging, the display filters switch from Beyond Compare's traditional ones to new ones that check the merging status of each line. Using those filters you can limit the display to just conflicts or just changes on one side or the other.


Data Compare Overview

A Data Compare session compares text files containing tabular data, such as .csv (comma separated values) files, in a side-by-side or over-under layout. The files are displayed in two grids that scroll together and the data is compared cell-by-cell.

Click to zoom

The display shows comparison columns, not necessarily the columns as they are organized in the data files. For example, the first comparison column may be comparing the third column of the left data file against the fifth column of the right file. See Data Compare Column Settings.

By default, Data Compare sorts your files before comparing them and aligns rows with matching key columns. You can define any combination of comparison columns as the key. If you specify an unsorted alignment, Beyond Compare will not sort the files, but will still only align rows with matching keys.

The display uses color to highlight differences. A row with a light red background indicates an important difference somewhere on the line, while light-blue indicates an unimportant difference. The light red background takes precedence over the light blue. This makes it easy to find differences, even if they are horizontally scrolled out of view. You can adjust these colors to suit your preferences.

See also

Data Compare Commands

Data Compare Settings

Data Format Settings

Data Compare Options


Hex Compare Overview

A Hex Compare session visually compares the raw content of two files, either in a side-by-side or over-under layout. It displays file content byte-by-byte, using the hexadecimal notation typical of hex editors.

Click to zoom

See also

Hex Compare Commands

Hex Compare Settings


Picture Compare Overview

A Picture Compare session compares a pair of image files visually, showing the differences between them.

Click to zoom

Aligning Image Content

You can compare images that have been resized, rotated, reflected or cropped.

Select View > Stretch to Same Size [image] to automatically widen the thinner image and heighten the shorter image before comparison.

Select View > Rotate Clockwise [image] or View > Rotate Counterclockwise [image] to rotate the current image ninety degrees to the right or to the left.

Select View > Flip Horizontally [image] or View > Flip Vertically [image] to reflect the current image across its x-axis or y-axis.

If one image is a cropped version of the other, you can drag the mouse over the difference pane to adjust the position of the right image's top left corner. To reset the offset back to (0,0) select View > Reset Difference Offset or simply click on the offset display on the toolbar. For finer control, use the arrow keys to nudge the offset one pixel at a time, or Ctrl+arrow keys to move by a larger amount. Note that the difference pane must be selected for the keyboard nudge function to work.

Tolerance Mode

Select View > Tolerance Mode [image] to have difference pixels indicate matches, unimportant differences, and important differences. It uses a configurable Tolerance to define the greatest degree of difference that is considered unimportant. You can also define Replacements to ignore specific color changes between images. By default, black pixels are used for matches, blue ones are used for unimportant differences, and red ones are used for important differences. You can change the colors to suit your preference. (See Picture Compare Options.)

Enable View > Ignore Unimportant Differences [image] to ignore any differences less than or equal to the tolerance. They will be handled the same as matching pixels.

Mismatch Range Mode

Select View > Mismatch Range Mode [image] to have difference pixels represent the degree of difference between the images. Black pixels are used for matches and yellow ones are used for differences. Brightness represents the degree of difference.

Binary Operation Mode

Select View > Binary Operation Mode [image] to have difference pixels be the result of a boolean operation on the RGB (red/green/blue) values of the images. The binary operation can be XOR, AND, or OR.

Blend Mode

Select View > Blend Mode [image] to use a configurable Blend percentage to combine the images. Decrease the percentage to make the right image more dominant.

See also

Picture Compare Commands

Picture Compare Settings

Picture Format Settings

Picture Compare Options


Registry Compare Overview

A Registry Compare session compares live registries on your computer or other computers on your network, and .reg export files in a side-by-side display.

Click to zoom

Keys and values are sorted and aligned based on their names. Keys will be colored based on whether they contain differences or orphans. Values will be colored to highlight character differences. Red indicates a difference and blue indicates an orphan.

Once the comparison is loaded, you can directly edit live registries. You can copy items between registries, delete or rename existing items, and add new items. Double clicking on a value also allows you to change its type and data.

See also

Registry Compare Commands

Registry Compare Settings


Text Edit Overview

A Text Edit view is a single-pane text editor.

Click to zoom

See also

Text Edit Commands

Text Format Settings

Text View Options


Other View Types

MP3 Compare

An MP3 Compare session compares two MP3 files with differences in tag fields highlighted.

Click to zoom

See also

MP3 Compare Commands

MP3 Compare Settings

Version Compare

A Version Compare session compares version info in a pair of executable files.

Click to zoom

See also

Version Compare Commands

Version Compare Settings

Beyond Compare 2 Plug-ins

Beyond Compare 3 for Windows can use plug-ins designed for version 2 (although most of our version 2 plug-in functionality is now built into version 3). To install a plug-in, copy the .bcp file to Beyond Compare 3's program folder. Restart Beyond Compare, select Tools > File Formats [image], click New and add an appropriate format definition for the plug-in.


File Formats

Beyond Compare uses file formats to specify how certain types of files are to be handled. For example, files with a .jpg or .png extension are associated with Picture Compare, while .c and .cpp files are recognized as having C/C++ syntax and are handled by Text Compare. You can modify the built-in file formats or create your own.

File formats determine:

· The type of viewer used for visual comparison
· What conversion, if any, should be performed before and after comparison
· The syntax, or grammar, of the file's content
· Case sensitivity of grammar elements
· Tab stops
· Line weights to help the alignment process

File formats primarily control how the file viewers handle your files, but they can also affect how a folder session compares file contents. If you use rules-based content comparison, then the folder session can limit the display to only files with important differences.

See also

File Format Management

Rules vs. File Formats


Grammars

A file format specification can include a grammar definition, used for syntax highlighting, and to help define which differences are important.

For example, our standard file format for C/C++ source code includes a grammar that recognizes keywords, comments, and literal strings. By flagging differences in comments as unimportant, you can better concentrate on important differences.

A grammar definition in Beyond Compare 3 is fairly simplistic. It does not support nested or context-specific definitions, so it doesn't handle tagged languages like HTML and PHP very well. On the other hand, it is a big step up from Beyond Compare 2's functionality.

To edit a grammar, select Tools > File Formats [image] and find the appropriate file format. Select the Grammar tab and edit the grammar items.


Reports

Comparison reports allow you to save the information from a comparison to view later without re-running the comparison. These reports can be printed directly from Beyond Compare, or saved in HTML or plain text format.

The report feature is available on the Session menu in various types of sessions. For instance, in a Folder Compare session you would select Session > Folder Compare Report [image].

The style of reports available differs for the various session types, but the options are much the same. You can output a report to any of these locations:

· Printer
· HTML report (file or clipboard)
· Plain text (file or clipboard)

The HTML and Printer choices support difference highlighting with color.

You can preview a Printer report with the Print Preview command, or an HTML report with the View in Browser command.


FTP Access

In general, wherever base folders are used in Beyond Compare, you can use a folder on an FTP site instead.

Browsing to an FTP folder

Beyond Compare's Browse for Folder [image] | [image] dialog has a tab for FTP sites. On it, you can select a previously defined FTP profile, or enter a new host name and other parameters. An FTP profile is automatically created with each new combination of host name, protocol, and username that doesn't use the defaults.

The Initial remote folder field identifies the base folder on the FTP site. You can click Connect & Browse to find the folder interactively.

Typing an FTP specification

You can type an FTP specification directly into either of the base path edit controls by using this syntax:

ftp://username@ftp.hostname.com

The program will prompt for the password as needed. Or, you can include the password in the specification:

ftp://username:password@ftp.hostname.com

Leave the username off for anonymous access:

ftp://ftp.hostname.com

You can specify a folder relative to the login folder:

ftp://username@ftp.hostname.com/subfolder

...or relative to the site's root folder:

ftp://username@ftp.hostname.com//subfolder

To specify SFTP (SSH2) access, use this syntax:

sftp://username@hostname.com

To specify FTP over SSL (explicit SSL), use this syntax:

ftps://username@hostname.com


Using Snapshots

On the Tools menu, the Save Snapshot [image] command saves a compressed read-only listing of the specified folder and all of its subfolders, including each file's timestamp, size, and file attributes. Snapshots have a .bcss file extension.

Snapshots are useful for detecting changes over time. Snapshot files can be loaded at a later date and compared to a live folder. You can load a snapshot just like any other base folder. Binary and rules-based content comparisons do not work on snapshots, since the files in the snapshot do not really exist.

If CRCs of the files are included in the snapshot, then CRC comparisons can be used to determine whether the contents of files have changed. This can be useful for detecting data corruption and other subtle changes to your data.

A snapshot remembers the name of the base folder it was produced from. If you load a snapshot on the command line (or drag a snapshot file onto the Beyond Compare icon), the program will automatically compare the snapshot with the original folder.

See also

Saving Snapshots


Renaming Files

Regular Expression Renames

In a Folder Compare session you can rename a group of files or folders all at once using Perl-compatible Regular Expressions.

In a Folder Compare session, select two or more files with different names, and select Rename [image] from the Actions menu. In the Rename dialog select Regular expressions. In the Old mask field, enter a regular expression that is matched against the original filename. In the New mask Field, enter a template used to generate a new filename.

A template is the expression used with the regular expression defined in the old name field to create a new filename.

Example - Partial Name Change:

If "ABCDEF" is the file name, and you want to change "CD" to "HJ", enter "CD" in the Old mask field and "HJ" in the New mask field. The new filename will be "ABHJEF".

Example - Complete Name Change:

If "Beyond" is the file name, and you want to change it to "Scooter", enter ".*" in the Old mask field and "Scooter" in the New mask field.

You can also change the filename by entering "Beyond" in the Old mask field and "Scooter" in the New mask field. However, for simple renames, it's easier to use the DOS compatible option.

Example - Changing a group of filenames

If you have a group of text files with six-letter names, and you want to swap the first three and the last three letters, enter "(...)(...).txt" in the Old mask field and "$2$1.txt" in the New mask field. In this case, "beyond.txt" becomes "ondbey.txt".

Another example is if you have a group of music files that are titled "Artist-Song" and you want to change them to "Artist - Song", enter "-" in the Old mask field and " - " in the New mask field.


Sample Regular Expressions

Expression | Meaning
^abc | Match "abc" at beginning of line
abc$ | Match "abc" at end of line
^abc$ | Match the line "abc" exactly
^\s*abc | Match "abc" at beginning of line, but allow leading whitespace
^\s*end;?\s*$ | Match a line containing only "end" or "end;" with leading or trailing whitespace
abc|def | Matches either "abc" or "def"
a(b|c)d | Matches "abd" or "acd"
a(b|c)d\1 | Matches "abdb" or "acdc", but it does not match "abdc"

Control characters used in above samples

Character | Meaning
^ | Beginning of line
$ | End of line
\s | Whitespace (a tab or space)
* | Zero or more of the preceding character
? | Preceding character is optional
| | Alternative expression
( ) | Subexpressions
\1 | Back reference to 1st subexpression

See also

Regular Expression Reference


Calling Beyond Compare from Other Applications

As you would expect, Beyond Compare's setup program creates shortcuts to the main executable file, such as:

C:\Program Files\Beyond Compare 3\BCompare.exe

However, if you call Beyond Compare from a batch file or a version control system, we recommend using "BComp" instead of "BCompare.exe". BComp is a helper program which launches Beyond Compare and waits until it is closed. For more technical details, see Command Line Reference.


Moving Beyond Compare to Another Computer

To copy or move Beyond Compare to a different computer:

1. On the new computer, download and install the latest version of Beyond Compare.
2. Enter your registration key in the new installation.
3. Run Beyond Compare on the old computer and from the Tools menu choose Export Settings to save all desired settings in a file.
4. Copy this settings file to the new computer.
5. Run Beyond Compare on the new computer and from the Tools menu choose Import Settings to load the settings file.

Note If you have Beyond Compare version 2.0 or older on the old computer, you will not have an Export Settings command. You can contact Scooter Software for assistance in transferring your settings.

See also

Exporting Settings

Importing Settings


Automating with Scripts

Beyond Compare provides a script processing feature which allows you to automate routine tasks. A script is a simple text file containing a list of commands which can control the program and automatically perform file operations or produce reports.

Scripts run without displaying the usual Beyond Compare user interface, but might require input for certain confirmations. To execute a script, specify it on the command line with a leading '@' symbol, as in:

BCompare.exe @"C:\My Folder\My Script.txt"

bcompare @"My Folder/My Script"

At its most basic, a script is a simple series of commands. See Scripting Reference for a list of all scripting commands. The shortest meaningful script would be something like:

load "C:\My Folder"

select all

delete all

which deletes all files and folders within the specified folder.

Scripts essentially manipulate an invisible folder session: file operations require selections, the "display" can be limited with filters, and folders can be "expanded" to recurse into them. Any folder name argument can be a folder on your system, on the network or an FTP site, or the name of a folder-like archive such as .ZIP, .CAB, or Beyond Compare Snapshot file.

Scripts are processed line by line, with a single command per line. Scripts are not case sensitive, and blank lines and comments (anything after a '#') are ignored. Arguments are separated by spaces. To include a space in an argument, surround the argument with quotes ("). To continue a long command on a second (or third) line, add an ampersand (&) at the end of every line but the last.

In addition to the standard commands, command line parameters and environmental variables can be inserted into the script at run time. Command line variables are specified by a percent sign (%) and a single number from 1-9. The script name and command line switches starting with / are not included in the 1-9 list. The scripting command:

load "%1"

would load whatever session was given on the command line, as in:

BCompare.exe @"My Script.txt" "My Session"

Environmental variables are inserted by enclosing the variable name in percent signs, and are case sensitive. The following performs the same as the earlier script, except it gets the folder from the environment:

load "%TMP%"

select all

delete all

There are several dynamic variables that Beyond Compare can fill in at each line of the script. The %date% variable fills in the current date in the format yyyy-mm-dd. The %time% variable's format depends on your computer's regional settings. The %fn_time% variable outputs the time as hh-mm-ss, which can be used for filenames.

Scripting Command Line Switches

Note Linux users should prefix the switches with "-" instead of "/".

The command line switches that affect scripting are /closescript, /leftreadonly, /readonly, /rightreadonly, and /silent. Normally, script processing adds an entry on the Task Bar and displays a Scripting Status Window detailing its progress and any errors. The /silent switch bypasses the Task Bar entry and Scripting Status Window, allowing Beyond Compare to process the script invisibly.

Scripting Options

To change the script processing options, select Options [image] from the Tools menu and then select Scripts. Mark the Beep when finished checkbox to have Beyond Compare sound an audible beep when it completes script processing. This beep can alert you to check and close the Scripting Status window. Close when finished causes Beyond Compare to automatically close its Scripting Status window when it completes script processing. When used in conjunction with Beep when finished, the beep simply tells you the process has completed.

There is also a place to designate a Shared scripts folder. When you provide a script name argument on the command line with no path designation, and there is no file of that name in the current folder, Beyond Compare will look in the Shared scripts folder for that script.


Sample Scripts

The following are some sample scripts to show how Beyond Compare can use scripts. You can either use these scripts as is or model your own scripts after them.

Here is a basic script which copies all of the newer and orphaned files from one folder to another, using a previously created session:

load "Sync Laptop"

sync update:left->right

Synching two folders

Here is a more advanced script which syncs two specific folders using advanced filters. This works the same as loading the folders in a Folder Compare session and performing a "Mirror Left to Right" folder synchronization.

# Turn logging on.

log normal "C:\My Log.txt"

# Load the default session and exclude all but certain file types.

load <default>

filter "*.html;*.htm;*.png;*.jpg"

# Load the base folders.

load "C:\My Folder" ftp://user@website.com/folder

# Copy different files left to right, delete orphans on right.

sync mirror:left->right

Comparing two files by name

This script compares two files by name.

file-report layout:side-by-side &

options:display-mismatches &

output-to:%3 %1 %2

A sample command line, calling the above script:

BCompare.exe @"My Script.txt" "My File.txt" "Your File.txt" "My Report.txt"

Note An ampersand (&) at the end of a line means that the command continues on the next line.

Note %1, %2, and %3 refer to the 1st, 2nd and 3rd command line argument, respectively.

Generating a report

This script compares two files by name and generates an html report showing differences with context:

text-report layout:side-by-side &

options:ignore-unimportant,display-context &

output-to:%3 output-options:html-color %1 %2

Keeping a web site in sync

This script keeps a web site in sync with development files.

# Turn verbose logging on.

log verbose append:"C:\My Log.txt"

# Set the comparison criteria.

criteria timestamp size

# Load source and target folders.

load "C:\My Folder" ftp://user@website.com/folder

# Filter to only include source files, ignore CVS subfolders.

filter "*.htm;*.html;*.php;*.jpg;*.gif;-CVS\"

# Sync the local files to the web site, creating empty folders.

sync create-empty mirror:left->right

Performing a rules-based comparison and logging results to a file

This script logs the script results to a file that uses the current date as part of the name. The variable %date% is expanded by the script in the format 2012-12-31 on U.S. English systems, on other systems it will match the system locale. It performs a rules-based comparison of Pascal source files and generates a report of mismatches.

# Log to a file of the form "C:\My Log 2012-12-31.txt".

# The exact format depends on your regional and language settings.

log verbose append:"C:\My Log %date%.txt"

# Compare the text contents of the files.

criteria rules-based

# Only compare Delphi source files, ignore the archive folder.

filter "*.pas;*.dfm;*.dpr;*.inc;-archive\"

load "C:\My Folder" "C:\Your Folder"

folder-report layout:summary &

options:display-mismatches,column-attributes,column-timestamp,column-size &

output-to:"My Report.txt"

Comparing current folder state to a snapshot

This script compares the current state of a folder to a snapshot from the last time updates were sent out. Then it copies the changed and new files to a zip file and updates the snapshot of the folder.

option confirm:yes-to-all

# Compare using crc.

criteria crc

# Load current files against snapshot from the last patch.

load "C:\My Folder" "C:\My Snapshot.bcss"

# Expand to affect subfolders and files.

expand all

# Select updated files.

select left.diff.files left.orphan.files

# Copy changes to a zip file.

copyto left path:relative "C:\My Archive.zip"

# Update the snapshot.

snapshot save-crc left output:"C:\My Snapshot.bcss"

Generating a report of differences

This script generates a report of only differences.

# Set up basic comparison features.

criteria timestamp:2sec

# Filter out log files.

filter "-*.log"

# Load first comparison.

load "C:\My Folder" "C:\Your Folder"

# Compare files with timestamp differences.

select newer.files older.files

# Generate a report of the differences.

folder-report layout:summary options:display-mismatches output-to:"C:\My Report.txt"


Scheduling a Script

You can use Beyond Compare's script processor to perform certain tasks, such as synchronizing folders, without interaction. For example, to automate a backup of "C:\My Folder", enter the following script commands into Notepad:

load "C:\My Folder" "C:\My Backups"

expand all

select left.newer.files left.orphan.files

copy left->right

Save this text file as "C:\My Scripts\Sync.txt".

A Beyond Compare script can be run at any desired time by using Window's Task Scheduler:

1. Open the Control Panel and double-click Schedule Tasks.
2. Double-click Add Scheduled Task.
3. In the Scheduled Task Wizard, select "Beyond Compare 3" from the list of installed applications and follow the instructions.
4. Double-click the newly created scheduled task to open the Properties dialog.
5. In the Run field add a reference to your script file:
BCompare.exe @Sync.txt
6. Change the Start In field to be the location of the script file:
"C:\My Scripts"

Note If you are running Windows XP, you will first need to select Performance and Maintenance from the Control Panel before selecting Schedule Tasks.

We recommend including a log command in your script. If you have trouble with your script, check out the Scheduled Tasks error log: "SchedLgU.txt" in your Windows folder.


Settings Reference

Beyond Compare is highly configurable, and it sometimes can be hard to know where to go in the program to change a specific setting. Here's where to look:

Program Options

General user preferences are set in the Options dialog. From the Tools menu, select Options [image]. From here you can set startup options, control confirmation messages, and customize display colors and fonts.

Commands

You can define your own keyboard shortcuts and toggle the visibility of various toolbar and menu items. From the Tools menu, select Customize Commands [image].

Session Settings

Most of the options that define the scope and rules of a comparison can be found in the Session Settings dialog. Each session type has its own session settings dialog. Select Session Settings [image] from the Session menu to open the dialog, or simply click the Rules [image] icon on the toolbar.

Session settings are stored with your saved sessions.

File Formats

You can configure how Beyond Compare handles specific file types. From the Tools menu, select File Formats [image].

File formats determine:

· The type of viewer used for visual comparison
· What conversion, if any, should be performed before and after comparison
· The syntax, or grammar, of the file's content
· Tab stops
· Which grammar elements are important or unimportant to the comparison
· Line weights to help the alignment process

FTP Profiles

You can configure how Beyond Compare connects to specific FTP servers. From the Tools menu, select FTP Profiles.

Source Control Integration

You can configure Beyond Compare to support checking files in and out of source control. From the Tools menu, select Source Control Integration.

Tweaks

Tweaks are advanced or obscure program options that we have decided not to include in the normal user interface.

Press Ctrl+Shift+T to access the Tweaks dialog.

Editing tweaks should be self-explanatory. Contact Scooter Software if you require assistance.


Program Options

Tools > Options

To set program preferences:

1. From the Tools menu, choose Options [image] to open the Options dialog.
2. In the list at the left, click the item containing the options you want to set:

Startup

General

Tabs

Backups

Open With

Scripts

Folder Views

Confirmations

Display

Compare Colors

Log

File Views

Display

Compare Colors

Next Difference

Text

Data

Picture

3. On any page, click Factory Defaults to revert the options on that page back to Scooter Software's default settings.
4. Modify the desired settings, and then click Apply to accept the changes, or OK to apply and close.


Startup Options

Tools > Options > Startup

Startup options:

When Beyond Compare starts up, it normally shows the Home view. To have the program automatically start up with the same sessions that were open the last time you used Beyond Compare, specify the same workspace name in the Load workspace and On Exit, save workspace as fields. You can also use the Save Workspace As and Load Workspace commands on the Session menu for further control.

When you start Beyond Compare with a pair of files specified, the program can display a dialog with a comparison summary, rather than taking the time to display the entire side-by-side comparison. To preface a file comparison with the Quick Compare dialog:

1. Mark the checkbox labeled When starting with file comparison, show quick compare dialog.
2. Select Binary quick compare to perform a byte-by-byte comparison, or Rules-based quick compare to use the file format settings appropriate for the specified files.
3. Mark the Open view automatically if files are different checkbox if you want the dialog to only appear when the files match.

The Check for updates every XXX days option determines how often Beyond Compare checks our website for new versions of the software.

To add Beyond Compare to Explorer's right-click menu:

Mark the Include Beyond Compare in Explorer context menu checkbox.

Select any of the optional commands listed in the table and choose Main menu or Submenu to include it in the context menu. Enable Compare Using to add a submenu that lists specific views, such as the Data Compare view and the Hex Compare view. This allows you to override the view that would normally be selected via the file formats list. Enable Merge to add 3-way merge support to the context menu. Enable Sync to support synchronizing folders from Explorer. Enable Edit to support editing a single file from Explorer. Enable Compare to Registry to support comparing a registry file to the live registry.


General Options

Tools > Options > General

These options control some of the general features of Beyond Compare.

To customize the Home view:

Enable Include session management to expose a tabbed session settings control on the Home view.

Set the maximum number of auto-saved sessions to store. Once this limit is passed, the oldest auto-saved sessions will be automatically deleted. Enter zero (0) to disable the auto-save sessions feature.

Interface options:

Edit these options to show Large buttons with text labels on the toolbars, to Show hints for toolbar buttons, etc. or to Show keyboard shortcut in hints. Here is what a toolbar looks like when all of these options are enabled:

The ESC key closes file views option applies to all file view types, such as Text Compare, Data Compare and Picture Compare. It does not affect folder views.

Shared Sessions:

Specify a Shared sessions file. Shared sessions will appear in your session tree. You can use but not modify them. Use Tools > Export Settings to create a shared sessions file.

Available session types:

This list controls which session types are offered for new sessions. Unmark the types of sessions that you don't want to use, in order to simplify the user interface. Saved sessions of a disabled type will still appear and function normally.

The list will also show any Beyond Compare 2-style plug-ins that have been installed. To install a plug-in, copy the .bcp file to Beyond Compare's program folder. Then select Tools > File Formats [image], click New and add an appropriate format definition for the plug-in.


Tab Options

Tools > Options > Tabs

When working with multiple sessions simultaneously, Beyond Compare can open them in independent windows, or under tabs in a single window. These options control that behavior.

To control new sessions:

Select either A new window or A new tab for newly created sessions.

To control child sessions:

Select either A new window or A new tab for newly created file sessions that are opened directly from a folder session.

To control miscellaneous tab behavior:

Set these options to reflect your preferences.

If you uncheck both Closing last remaining tab closes the window and Hide tab bar if single tab then closing the last tab will return to the Home view.


Backup Options

Tools > Options > Backups

Beyond Compare can create a backup of your files before overwriting them during a copy or move operation, or before saving an edited file. Set these options to control how backup files are named and where they are stored.


"Open With" Applications

Tools > Options > Open With

You can configure external applications to appear in the Open With submenu.

Click New to add an application.

Enter a name in the Description field to appear on the Open With menu.

To define a keyboard shortcut for the application, focus on the Shortcut field and press the desired keystroke. Click Remove to remove an assigned shortcut.

Enter a suitable Command line specification for launching the application. It can include command line switches appropriate to that application. The following variables will be replaced with the indicated information:

%f | Absolute path and filename
%l | (lowercase L) Current line number in file view
%n | Filename only
%p | Absolute path
%x | Extension (includes '.')
%b | Filename without extension
%F | Path and filename relative to the working folder
%P | Path relative to the working folder

'1' and '2' can be appended to the end of variables to refer to the left/first or right/second file (eg. "BCompare %F2 %F1"). In all cases except for a second %f or %l (for backwards compatibility), leaving a number off will refer to the first file no matter how many times it's listed on the command line.

The Working Folder field allows you to change where the program executes (the "Start in" folder). If it is blank, the program is executed in the same working folder as Beyond Compare. You can specify a specific folder, or pick the special values <parent folder> and <base folder> from the dropdown list. <parent folder> will use the selected file's parent folder, while <base folder> will use the base folder of the selected side (or the parent folder in a file view).

Use the Path delimiter field to replace all path delimiters with the given string. If left blank, the normal delimiters will be used (eg. backslash (\) under Windows).

The Accepts files and Accepts folders options control whether the application should be available for files, folders, or both. Tip: You can configure Beyond Compare itself as an additional application for folders. That way, you can select folders and compare them in another instance of Beyond Compare.

Refresh when finished performs a Fast Refresh when Beyond Compare is done processing the Open With list.

When the Multiple instances option is enabled, you can select multiple files or file pairs, and execute the operation on all of them once per file or pair of lined up files. With this option, Beyond Compare checks to see if a second file would be given on the command line (eg. "%x2"). If it is, the application will execute on pairs at a time, otherwise it will break the pair up and execute once for each selected item in the pair.

Wait for previous instance to finish makes Beyond Compare wait until the previous command finishes executing before running the next command.


Script Options

Tools > Options > Scripts

Set these options to control how scripts are processed:

Enable Beep when finished for an audible cue that a script has finished.

Enable Close when finished to exit the program when the script has finished.

Specify a Shared scripts folder to be the location for shared scripts. If a script filename is not found in the current folder, Beyond Compare will look for it there.


Folder View Options

Tools > Options > Folder Views

Name filter presets

Specify the preset name filter choices, available on the folder view's toolbar. Use simple wildcard definitions separated by semicolons for the mask. Example:

*.htm;*.html;*.jpg

Archive associations

Specify the file types to be associated with each of the supported archive formats. Select a format and enter the associated file types separated by semicolons in the Mask for XXX field. You can leave the field blank to drop support for that format. You can add support for additional archive formats by clicking Add Plug-in and following the instructions. For more information, see Archive Files.

Miscellaneous

The read-only attribute is normally preserved when copying files. On read-only media such as CDs or DVDs, all files will still be marked read-only when they are copied to another location. To avoid this, enable the Remove read-only flag when copying from a CD or DVD option.


Folder View Confirmations

Tools > Options > Folder Views > Confirmations

Confirmations:

By default, Beyond Compare prompts for confirmation before performing various actions. Unmark any of these checkboxes to suppress the confirmation dialogs.

The Beep after long file operations option causes an audible sound when file operations such as copy and move are complete, unless they take less than 3 seconds.

Synchronize confirmations:

Select Prompt, Yes to All or No to All to control confirmations that might appear during a Folder Compare session's synchronize command.

How filters affect file actions:

By default, file filters and display filters are respected during file actions (such as Copy, Move and Delete), unless Suppress Filters [image] is on. To change the default behavior, mark the Include hidden items by default checkbox.


Folder View Display Options

Tools > Options > Folder Views > Display

These options allow you to customize overall colors and fonts used in folder views.

Font

By default, the font used for folder displays is the same as what the operating system uses. To change it, un-mark the Use system checkbox and click the Font button.

Selection

By default, a light green background color is used to highlight selected items. This allows the comparison colors to show even when selected. You can modify the selection color, or if you prefer, mark the Use system checkbox to use the operating system's scheme for highlighting selections.

Miscellaneous

Select the colors to be used for Filtered out items (when Suppress Filters is used), and for items whose comparison state is Unknown. Mark the Use Stripes checkbox to tint the background on every other line of the comparison.


Folder View Comparison Colors

Tools > Options > Folder Views > Compare Colors

These options allow you to customize the colors used to highlight differences in folder views.


Folder View Log Options

Tools > Options > Folder Views > Log

Set these options to include or exclude types of messages in the log:

Operation summaries

Log a summary of each operation.

Operation details

Log details of each operation, including each file affected.

Warnings

Log warnings and errors.

FTP trace

Log messages to and from FTP site.

To limit the memory usage of the log:

Enter a value for Display up to XXX messages. Once this limit is reached in a session, the oldest messages will be deleted.

To continuously write log messages to a text file:

Enter a file specification for Automatically save messages to file. The file will be created if necessary.


File View Options

Tools > Options > File Views

Thumbnail control for large files

Select Compress to fit to compress the thumbnail to the available vertical space. Select Allow scrolling to show a vertical scrollbar instead.

Displayed files changed externally

Mark the Check for files changed on disk checkbox to check for a newer copy of a file when returning focus to a file view. If found, Beyond Compare will prompt "File changed on disk, reload?" Mark the Automatically reload unless changes will be discarded checkbox to have Beyond Compare automatically load the newer file as long as you haven't made changes to the displayed file.


File View Display Options

Tools > Options > File Views > Display

These options allow you to customize visual aspects of the various types of file views.

Select an element from the list to change its visual treatment. You can change the Background color and Text color of each element on the list. Lower elements in the list override higher ones. Select Default to leave unchanged a color set by an element higher on the list.

Mark the Use Stripes checkbox to tint the background on every other line of the comparison.

By default, Beyond Compare uses a medium green color for selected text, so that difference coloring is not obscured. If you prefer the operating system's standard coloring for selections, pick Selection from the list of elements and mark Use system.

The list also includes syntax highlighting elements.

Click one of the Font buttons to change the overall font used to display text. The Editor font is used in Text Compare, Text Merge and Data Compare views. The Hex font is used in Hex Compare views, as well as the optional hex details display at the bottom of other views. The Listing font is used in all other views.

The Dim inactive pane by XXX % setting is used to darken the non-active side of the comparison, to help you focus on the active side.


File View Comparison Colors

Tools > Options > File Views > Compare Colors

These options allow you to customize the colors used to highlight differences in the various types of file views.

Set Important differences and Unimportant differences to your preference for those concepts. The font colors and background colors will be derived from these basic colors. By default, the basic color is used for the text color on differences, and a pale version of the color is used for the entire line's background color.

Click the Bold button to use a bold font style for differences.

Adjust the Background Contrast slider to make the background colors lighter or darker overall.

The Difference Enhancer slider controls foreground/background contrast for individual differences.

Mark the Use merge colors for compares checkbox to color one-sided lines as left or right additions (blue and purple) rather than differences (red).

Pick a basic color for indicating Left changes, Conflicts and Right changes. These colors will be used for icons and the thumbnail summary. Derived colors will be used for the background color on appropriate lines. For each of these colors there is a Shift Unimportant Color slider that modifies the hue used for unimportant differences. There is also an Additional Contrast slider that further lightens the unimportant color.


File View Next Difference Options

Tools > Options > File Views > Next Difference

Set these options to reflect your preferences concerning how to peruse differences.

Next difference:

When loading new files, go to first difference

Immediately position at first difference when a new text comparison starts.

Go to next difference after copying to other side

Position at next difference item after copying the current item to the other side.

Limit "Next Difference Files" to current folder

Limit the Next Difference Files command to finding files in the same parent folder.

When no more differences:

Wrap around to first difference

If the end of the comparison is reached when looking for a difference, position back at the first difference in the comparison.

Show message panel

Disable this option in order to suppress the message panel (and beep) when a difference is not found.


Text View Options

Tools > Options > File Views > Text

These options apply to Text Compare and Text Merge sessions.

Editing features

Auto indent

When enabled and a new line is created, it is automatically indented to match the leading whitespace on the previous line.

Backspace unindents

When enabled and positioned immediately after the leading whitespace on a line, pressing the Backspace key deletes enough whitespace to match the previous indentation level, as defined by preceding lines.

Allow positioning beyond end of line

When enabled, the edit cursor is not constrained by the end of text on a line.

Display options

Most of the display settings for Text Compare and Text Merge are found on the Display and Compare Colors pages of the Options dialog. Settings specific to the text editors are here.

You can add or subtract pixels from Extra line spacing to change the density of text in the view.

To show a vertical line at a specific column position, set Show column line at to the desired value. Set it to zero (0) to hide the line. If you use a proportionally spaced font, the column position will be determined by the width of the space character.

Enable Show filtered line counts to display a summary of lines hidden by display filters:

To use an alternate font for the narrower input panes in a Text Merge session, enable Different font for merge input panes.

Other miscellaneous options

Initialize "Text to find" to be current word

Causes the current selection to be filled in as the search text for the Find [image] command.

Number of context lines

Defines the number of matching lines to display before and after a difference section when the Text Compare's Show Context [image] is used.


Data Compare Options

Tools > Options > File Views > Data

The Details resize columns to fit option causes the Row Details area at the bottom of a Data Compare view to size columns to fit the specific rows displayed there, rather than matching the column widths in the main comparison display.


Picture Compare Options

Tools > Options > File Views > Picture

You can change the colors used in Tolerance mode in Picture Compare sessions.

Change the Solid color as desired, or select Gray scale, Red scale or Blue scale to "tint" the left image, so that it shows through on the difference pane.

Turn on Show transparency as checkerboarding to indicate which pixels in the original images are transparent.

Set the Background color to control the color of the panes that hold the images.


Customize Commands

Tools > Customize Commands

From the Tools menu, choose Customize Commands [image]. In this dialog you can control which commands appear in menus and on toolbars, and you can set keyboard shortcuts for commands. Since the menus and toolbars change depending on the type of window, you need to open a session to customize the commands for that session type.

In the [image] search field, type the name or description of the command you are looking for in order to limit the list of commands.

Select a command in the list to edit. The command's description will appear below the list.

For most commands, you can enable or disable Show command in menu and/or Show command on toolbar. Some commands also have a Show command on dropdown option that positions the command on a drop-down menu connected to a toolbar button.

To change the keyboard shortcut, focus on the Shortcut field and press the desired keystroke. Click Remove to remove an assigned shortcut or Default to revert it to the factory default setting. If a keyboard shortcut is already assigned elsewhere, a warning appears and you have the option of reassigning it.

Most session types have display filters commands available. For those, Display filter presets are available for quickly selecting popular toolbar layouts (DropDown, Favorites or Toggles). These presets can also be selected by right-clicking the toolbar.

Enable Lock toolbar positions to disable drag-and-dock on the toolbar.

For documentation of specific commands, see Commands Reference.


Session Settings

To edit session settings:

1. From the Session menu choose Session Settings [image].
2. Modify the desired settings on each tab.
3. The drop-down selection at the bottom of the dialog controls the scope of your changes. Select Use for this view only to affect the current session, or Update session defaults to apply your changes to all new sessions of this type.

Additional choices are shown for child sessions, comparisons spawned from a folder session. Use for these files within parent session causes the current folder session to remember these settings and use them whenever this particular pair of files is compared. Use for all files within parent session causes these settings to be used for any new sessions of this type spawned from the current folder session.

4. Click OK.

Specific settings for session types:

Folder Compare

Folder Sync

Text Compare

Text Merge

Data Compare

Hex Compare

MP3 Compare

Picture Compare

Registry Compare

Version Compare


Folder Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

These settings control which folders to compare.

Comparison

Handling

Name Filters

Other Filters

Misc


Folder Compare Comparison Settings

Session > Session Settings > Comparison

These settings control what is considered a difference in a folder session.

Quick tests

These comparison tests can be performed simply by reading directories and are much quicker than tests that require reading individual files.

Compare file size

Marks files as different if file sizes differ.

Compare timestamps

Compares files' date and time last modified. Timestamps must differ by more seconds than the Tolerance to be considered mismatches.

Ignore daylight saving difference ignores exact hour differences. This is useful for dealing with the way that different file systems handle Daylight Savings Time.

Ignore timezone differences ignores timestamp differences that are multiples of an exact hour.

Compare filename case

Marks files as different if character capitalizations differ.

Compare file attributes

Archive compares files' archive attribute. Since merely copying a file can change its archive attribute, you should normally disable this option.

System compares files' system attribute.

Hidden compares files' hidden attribute.

Read-only compares files' read-only attribute.

Tests that require reading files

Compare contents

Enables size or content-related comparisons.

CRC comparison compares CRC values. A CRC (Cyclic Redundancy Check) is a numeric representation of the contents of a file. If the CRCs of two files are different, then the contents of those files must be different. If the CRCs match, then it is likely (but not certain) that the contents match.

Binary comparison compares files byte-by-byte.

Rules-based comparison compares files based on their file format associations. Allows you to ignore differences in line endings, whitespace, or source code comments.

Enable Skip if quick tests indicate files are the same when you only want to perform the slower, more thorough tests when timestamps are different.

Compare versions

Compares version information, typically stored in application files (.exe, .dll, .ocx, etc).

Override quick test results

If enabled, a content comparison that finds identical contents will show the files as matching, even though there are differences in timestamps or other quick tests.


Folder Compare Handling

Session > Session Settings > Handling

Folder handling

Automatically scan subfolders in background causes folders to be read in the background when a comparison is loaded. This way, folders can be colored appropriately before you open them. Top-level orphan folders can usually be colored and filtered without scanning, since they can only contain other orphans. Automatically scan top-level orphan subfolders causes these orphan folders to be scanned anyway, so that the folder's size is accurately reported.

Expand subfolders when loading session opens all folders automatically when a comparison is loaded. Only expand subfolders with differences limits auto expansion to folders that are found to have mismatches.

Archive handling (eg. zip files)

As files always treats archive files like other files. They will sort with files and not show a folder icon.

As folders once opened sorts and compares archive files like other files, but with a zip folder icon. Once you open the zip folder, its comparison status changes to reflect its contents, like other folders do.

As folders always treats archive files like regular folders.

File handling

Touch local files when copying to an FTP site

Many FTP sites do not allow Beyond Compare to control file timestamps, so when a file is copied to the FTP site, its date will not match the local copy. This option changes the local file timestamp to match the FTP copy.

Bypass disk cache during binary comparisons

Reads files directly from the media, avoiding the operating system's disk cache. This ensures an accurate comparison after copying to questionable media.

Follow symbolic links

Displays symbolic links and NTFS junction points as if they were their target. This includes whether they will be shown as files or folders, their size, their last modified time, and their attributes.

Maintain DOS 8.3 aliases

Tries to keep the same short (DOS 8.3) filenames when copying files.

Copy NTFS file permissions

Copies security descriptors of files on NTFS file systems under Windows 2000 or newer. This feature does not preserve permissions of files edited from Text Compare sessions.

Automatic refresh

Set this option to periodically refresh the folder comparison.


Folder Compare Name Filters

Session > Session Settings > Name Filters

You can include or exclude folders and files based on their names by using one or more file masks.

To set a name filter:

Add a file mask to the appropriate list. Each file mask must be on its own line.

· Include Files Files to include in this session.
· Exclude Files Files to exclude from this session.
· Include Folders Folders to include in this session.
· Exclude Folders Folders to exclude from this session.

For examples, see the File Masks topic.

To clear all name filters:

Click the Clear button to clear all the filter settings on this tab.

To make the current name filter a preset:

Click the Add To Presets button, optionally enter a Name, optionally edit the Mask, and click OK.


Folder Compare Other Filters

Session > Session Settings > Other Filters

You can exclude files from a folder session based on criteria other than their names.

To filter by date:

1. Select Date from the list of filter types.
2. If Use days ago is enabled, filters will be the number of whole days relative to 12:00AM on the date when the comparison is run. If it is disabled, filters will use absolute dates and times.
3. Enable Exclude files that are older than or Exclude files that are newer than to define a filter. Enable both to include files within a range of dates.

To filter by size:

1. Select Size from the list of filter types.
2. Enable Exclude files that are smaller than or Exclude files that are larger than to define a filter. Enable both to include files within a range of sizes.

To filter by DOS attributes:

1. Select DOS attributes from the list of filter types.
2. Select the options you want to control exclusion. Exclude protected operating system files is enabled by default.

To filter by source control status:

1. Select Source control status from the list of filter types.
2. Select the options you want to control exclusion.

To filter by text content:

3. Select Text content from the list of filter types.
4. Select the options you want to define the text search. If a match can't be found in a file, it will be excluded.

Note When any of the above filters is in effect, a comment bar appears near the bottom of the folder view. You can click the [image] icon on the bar to edit these filters.

Note If a file filter determines that a file on one side of the comparison should be hidden but the corresponding file on the other side should be visible, both are made visible and the one that should be hidden will be colored teal (blue-green).

To clear all other file filters:

Click the Clear button to clear all the filter settings on this tab.


Folder Compare Miscellaneous Settings

Session > Session Settings > Misc

In the absence of alignment overrides, a folder session aligns files and subfolders by name, left and right. You can manually change the default alignment.

To force a different alignment:

Click New to add an alignment override.

In the Alignment Override dialog, fill in the Align left file (or folder) and with right file (or folder) fields. You can use * and ? wildcards in your entries, or enable Regular expression to interpret your entries as replacement-style regular expressions. Use Limit to this folder to specify a relative path for the alignment.

Examples:

Align left file (or folder) | ... with right file (or folder) | Description
x.txt | x.csv | Lines up "x.txt" with "x.csv".
*.gif | *.png | Lines up all GIF files with PNG files of the same name.
x*.jpg | y*.jpg | Lines up files such as "x1.jpg" with "y1.jpg" and "x2.jpg" with "y2.jpg".

Note The easiest way to manually align two items in a folder session is to right-click the first item, select Align With, then click the second item.

To override file format associations:

The Enabled file formats list lets you override which file formats will be used by this folder session. A file format is listed in bold if its enabled state in this session is different from its global enabled state. You can create a custom file format that is enabled for use in this session but disabled in the global list.


Folder Sync Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

These settings control which folders to compare.

Sync

Comparison

Handling

Name Filters

Other Filters

Misc


Folder Sync Synchronize Settings

Session > Session Settings > Sync

Actions

Presets

You can use one of the predefined sync methods described in the overview or create a custom one.


Folder Sync Comparison Settings

Session > Session Settings > Comparison

These settings control what is considered a difference in a folder session.

Quick tests

These comparison tests can be performed simply by reading directories and are much quicker than tests that require reading individual files.

Compare file size

Marks files as different if file sizes differ.

Compare timestamps

Compares files' date and time last modified. Timestamps must differ by more seconds than the Tolerance to be considered mismatches.

Ignore daylight saving difference ignores exact hour differences. This is useful for dealing with the way that different file systems handle Daylight Savings Time.

Ignore timezone differences ignores timestamp differences that are multiples of an exact hour.

Compare filename case

Marks files as different if character capitalizations differ.

Compare file attributes

Archive compares files' archive attribute. Since merely copying a file can change its archive attribute, you should normally disable this option.

System compares files' system attribute.

Hidden compares files' hidden attribute.

Read-only compares files' read-only attribute.

Tests that require reading files

Compare contents

Enables size or content-related comparisons.

CRC comparison compares CRC values. A CRC (Cyclic Redundancy Check) is a numeric representation of the contents of a file. If the CRCs of two files are different, then the contents of those files must be different. If the CRCs match, then it is likely (but not certain) that the contents match.

Binary comparison compares files byte-by-byte.

Rules-based comparison compares files based on their file format associations. Allows you to ignore differences in line endings, whitespace, or source code comments.

Enable Skip if quick tests indicate files are the same when you only want to perform the slower, more thorough tests when timestamps are different.

Compare versions

Compares version information, typically stored in application files (.exe, .dll, .ocx, etc).

Override quick test results

If enabled, a content comparison that finds identical contents will show the files as matching, even though there are differences in timestamps or other quick tests.


Folder Sync Handling

Session > Session Settings > Handling

Folder handling

Sync empty folders will affect folders without content or whose entire contents have been filtered out.

Expand subfolders when loading session opens all folders automatically when a comparison is loaded.

Sync within archives treats archive files like regular folders.

File handling

Delete to recycle bin if possible

Moves files and folders stored on a local drive to the recycle bin instead of permanently deleting them. This option is ignored for deletions from network drives, FTP sites and within archive files.

Touch local files when copying to an FTP site

Many FTP sites do not allow Beyond Compare to control file timestamps, so when a file is copied to the FTP site, its date will not match the local copy. This option changes the local file timestamp to match the FTP copy.

Bypass disk cache during binary comparisons

Reads files directly from the media, avoiding the operating system's disk cache. This ensures an accurate comparison after copying to questionable media.

Follow symbolic links

Displays symbolic links and NTFS junction points as if they were their target. This includes whether they will be shown as files or folders, their size, their last modified time, and their attributes.

Maintain DOS 8.3 aliases

Tries to keep the same short (DOS 8.3) filenames when copying files.

Copy NTFS file permissions

Copies security descriptors of files on NTFS file systems under Windows 2000 or newer. This feature does not preserve permissions of files edited from Text Compare sessions.

Automatic refresh

Set this option to periodically refresh the folder comparison.


Folder Sync Name Filters

Session > Session Settings > Name Filters

You can include or exclude folders and files based on their names by using one or more file masks.

To set a name filter:

Add a file mask to the appropriate list. Each file mask must be on its own line.

· Include Files Files to include in this session.
· Exclude Files Files to exclude from this session.
· Include Folders Folders to include in this session.
· Exclude Folders Folders to exclude from this session.

For examples, see the File Masks topic.

To clear all name filters:

Click the Clear button to clear all the filter settings on this tab.

To make the current name filter a preset:

Click the Add To Presets button, optionally enter a Name, optionally edit the Mask, and click OK.


Folder Sync Other Filters

Session > Session Settings > Other Filters

You can exclude files from a folder session based on criteria other than their names.

To filter by date:

1. Select Date from the list of filter types.
2. If Use days ago is enabled, filters will be the number of whole days relative to 12:00AM on the date when the comparison is run. If it is disabled, filters will use absolute dates and times.
3. Enable Exclude files that are older than or Exclude files that are newer than to define a filter. Enable both to include files within a range of dates.

To filter by size:

1. Select Size from the list of filter types.
2. Enable Exclude files that are smaller than or Exclude files that are larger than to define a filter. Enable both to include files within a range of sizes.

To filter by DOS attributes:

1. Select DOS attributes from the list of filter types.
2. Select the options you want to control exclusion. Exclude protected operating system files is enabled by default.

To filter by source control status:

1. Select Source control status from the list of filter types.
2. Select the options you want to control exclusion.

To filter by text content:

3. Select Text content from the list of filter types.
4. Select the options you want to define the text search. If a match can't be found in a file, it will be excluded.

Note When any of the above filters is in effect, a comment bar appears near the bottom of the folder view. You can click the [image] icon on the bar to edit these filters.

Note If a file filter determines that a file on one side of the comparison should be hidden but the corresponding file on the other side should be visible, both are made visible and the one that should be hidden will be colored teal (blue-green).

To clear all other file filters:

Click the Clear button to clear all the filter settings on this tab.


Folder Sync Miscellaneous Settings

Session > Session Settings > Misc

In the absence of alignment overrides, a folder session aligns files and subfolders by name, left and right. You can manually change the default alignment.

To force a different alignment:

Click New to add an alignment override.

In the Alignment Override dialog, fill in the Align left file (or folder) and with right file (or folder) fields. You can use * and ? wildcards in your entries, or enable Regular expression to interpret your entries as replacement-style regular expressions. Use Limit to this folder to specify a relative path for the alignment.

Examples:

Align left file (or folder) | ... with right file (or folder) | Description
x.txt | x.csv | Lines up "x.txt" with "x.csv".
*.gif | *.png | Lines up all GIF files with PNG files of the same name.
x*.jpg | y*.jpg | Lines up files such as "x1.jpg" with "y1.jpg" and "x2.jpg" with "y2.jpg".

To override file format associations:

The Enabled file formats list lets you override which file formats will be used by this folder session. A file format is listed in bold if its enabled state in this session is different from its global enabled state. You can create a custom file format that is enabled for use in this session but disabled in the global list.


Text Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

These settings control which files to compare.

Format

Importance

Alignment

Replacements


Text Compare File Formats

Session > Session Settings > Format

Specify the file format to be used when reading the left and/or right files. The default selection is Detected, which means the file format will be selected based on file masks.

Encoding overrides allow this session to override the character encoding to be used for each file, normally controlled by the selected file format. The default is None, which means the file format's encoding choice will be used.


Text Compare Importance Settings

Session > Session Settings > Importance

These settings control which differences you consider important in the current session. Important differences will be colored red in the comparison. Unimportant differences will be blue (or not highlighted at all if Ignore Unimportant Differences is enabled).

Grammar elements

Mark the boxes in the list of items that are important to the comparison. The list contains elements that are defined by the file format's grammar. Click the Edit Grammar button to examine or change the grammar definitions in the selected file format.

Default text

These settings control the importance of text not defined in the grammar (or for file formats that don't have a grammar defined).

Leading whitespace controls whether whitespace (spaces and tabs) at the start of the line is important.

Embedded whitespace controls whether whitespace in the middle of the line is important.

Trailing whitespace controls whether whitespace at the end of the line is important.

Everything else refers to non-whitespace text not already defined as a grammar element.

Mark Character case if the "everything else" text is case-sensitive. (The case sensitivity of grammar elements is controlled by the file format's grammar.)

Miscellaneous

To consider an extra blank line (or an inserted line with only unimportant text) an important difference, mark the Orphan lines are always important checkbox.

Beyond Compare normally ignores differences in line ending style, such as CR/LF in Windows text files vs. LF alone in Unix files. To find differences in line endings on a line-by-line basis, mark the Compare line endings (PC/Mac/Unix) checkbox. (To examine the line endings, enable the Visible Whitespace [image] option in the View menu.)

See also

Rules vs. File Formats


Text Compare Alignment Settings

Session > Session Settings > Alignment

The Alignment tab settings control the algorithm for aligning lines in the comparison.

The Standard method aligns the files by comparing successively smaller sections of each file. Parts of the alignment can be shown before the entire comparison is finished.

Skew tolerance represents how far the algorithm will look for matches. When comparing files with many or large inserts, a larger tolerance can improve the alignment.

The Use closeness matching option attempts to align the remaining mismatched lines based on their similarity.

The Alternate method aligns the files using a common LCS (Longest Common Subsequence) algorithm. This can give better matches in certain cases, such as large inserts or when the files contain a lot of repeating text. Since files are compared all at once, larger file scans take much longer than the standard method, and the files are not displayed until the comparison is complete. It does not support similarity comparisons, so mismatches will be grouped in blocks.

Select Unaligned to compare files without aligning lines based on their content.

Mark the Never align differences checkbox to show lines with important differences as blocks of added and deleted text rather than changed text.

Note Regardless of these settings, the alignment algorithm will sometimes produce undesirable results. To manually align two lines, right-click one line and select Align With and then click the second line.


Text Compare Replacements

Session > Session Settings > Replacements

Replacements identify repetitive changes that should be considered unimportant. You can specify the text to match on one side and the text that replaces it on the other side.

To define a replacement rule:

On the Replacements tab, click New.

Specify the Text to find and the Replace with text.

Mark Match character case to only match on text with the same uppercase and lowercase characters.

Mark Whole words only to prevent matching on parts of words.

Mark Regular expression to treat the search string as a PCRE regular expression. You can use the dropdown button to the right of the search string to insert common regular expression elements. Click the RE Examples button for more info.

Specify the Side of the editor pane that should be searched.


Text Merge Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

These settings control which files to merge.

Format

Importance

Alignment


Text Merge File Formats

Session > Session Settings > Format

Specify the file format to be used when reading the input files. The default selection is Detected, which means the file format will be selected based on file masks.

Encoding overrides allow this session to override the character encoding to be used for each file, normally controlled by the selected file format. The default is None, which means the file format's encoding choice will be used.


Text Merge Importance Settings

Session > Session Settings > Importance

These settings control which differences you consider important in the current session. Important differences will be colored red in the comparison. Unimportant differences will be blue (or not highlighted at all if Ignore Unimportant Differences is enabled).

Grammar elements

Mark the boxes in the list of items that are important to the comparison. The list contains elements that are defined by the file format's grammar. Click the Edit Grammar button to examine or change the grammar definitions in the selected file format.

Default text

These settings control the importance of text not defined in the grammar (or for file formats that don't have a grammar defined).

Leading whitespace controls whether whitespace (spaces and tabs) at the start of the line is important.

Embedded whitespace controls whether whitespace in the middle of the line is important.

Trailing whitespace controls whether whitespace at the end of the line is important.

Everything else refers to non-whitespace text not already defined as a grammar element.

Mark Character case if the "everything else" text is case-sensitive. (The case sensitivity of grammar elements is controlled by the file format's grammar.)

Miscellaneous

To consider an extra blank line (or an inserted line with only unimportant text) an important difference, mark the Orphan lines are always important checkbox.

Beyond Compare normally ignores differences in line ending style, such as CR/LF in Windows text files vs. LF alone in Unix files. To find differences in line endings on a line-by-line basis, mark the Compare line endings (PC/Mac/Unix) checkbox. (To examine the line endings, enable the Visible Whitespace [image] option in the View menu.)

See also

Rules vs. File Formats


Text Merge Alignment Settings

Session > Session Settings > Alignment

The Alignment tab settings control the algorithm for aligning lines in the comparison.

The Standard method aligns the files by comparing successively smaller sections of each file. Parts of the alignment can be shown before the entire comparison is finished.

Skew tolerance represents how far the algorithm will look for matches. When comparing files with many or large inserts, a larger tolerance can improve the alignment.

The Use closeness matching option attempts to align the remaining mismatched lines based on their similarity.

The Alternate method aligns the files using a common LCS (Longest Common Subsequence) algorithm. This can give better matches in certain cases, such as large inserts or when the files contain a lot of repeating text. Since files are compared all at once, larger file scans take much longer than the standard method, and the files are not displayed until the comparison is complete. It does not support similarity comparisons, so mismatches will be grouped in blocks.

Select Unaligned to compare files without aligning lines based on their content.

Mark the Never align differences checkbox to show lines with important differences as blocks of added and deleted text rather than changed text.

Note Regardless of these settings, the alignment algorithm will sometimes produce undesirable results. To manually align two lines, right-click one line and select Align With and then click the second line.

A merge conflict is...

These settings define the scope of conflicts. A conflict occurs when the same section of text has changes on both left and right sides.

Select Only different change lines to limit conflicts to where each line has changes on both sides. Select Left change and right change separated by lines to specify the maximum number of lines between changes that should be considered conflicts. This way, left and right changes that are close to each other can be flagged for review along with direct conflicts.


Data Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

These settings control which files to compare.

Format

Columns


Data Compare File Formats

Session > Session Settings > Format

Specify the file format to be used when reading the left and/or right files. The default selection is Detected, which means the file format will be selected based on file masks.

Encoding overrides allow this session to override the character encoding to be used for each file, normally controlled by the selected file format. The default is None, which means the file format's encoding choice will be used.


Data Compare Column Settings

Session > Session Settings > Columns

Each line in the display represents a comparison column, and shows:

· Comparison [image] if key, column number, column name
· Left file column number, sample data if available
· Right file column number, sample data if available
· Handling summary of column comparison

To control the alignment of rows:

Define as many columns as keys as necessary to uniquely identify each row. By default, the first column is the only one defined as a key. To define a column as a key, position on the appropriate line, click the Edit [image] button, mark the Key checkbox, and click OK. If multiple keys are defined, precedence follows the order in the comparison. If no keys are defined, the alignment will use all of the columns to uniquely identify each row.

By default, the files are sorted by their keys before the rows are aligned. Mark the Unsorted alignment checkbox to force the alignment to preserve the order of rows as they exist in the files. Note that this may cause rows with the same key column data not to be aligned.

To control the alignment of columns:

By default, the comparison assumes the columns of the files are in the same order. To change the comparison order of a column in the left file, position on the appropriate line under Left file, and click the Move Up [image] or Move Down [image] button as necessary. If you position under Comparison instead, those buttons will change the position of the comparison column itself. To prevent a column in the left file from being compared at all, position on the appropriate line under Left file, and click the Remove [image] button. If you position under Comparison instead, this button will prevent its file columns from being compared and delete this comparison column definition. To restore a removed column from the left file, position under Left file, right-click to pick Insert, mark items in the Insert Columns dialog and click OK. Click the Tidy button to remove any blank lines from the list.

To control the names of columns:

By default, column names are automatically determined from the left or right file. To give a column a specific name, position on the appropriate line, click the Edit [image] button, change the Name, and click OK. To revert all columns to automatic naming, select Reset Names from the list's right-click menu. If left file data is available, you can select Fill Names Using Left File from the list's right-click menu to force the names to be those found in the left file. Fill Names Using Comparison will force the names to be those that would be automatically determined.

To control how column data is compared:

Position on the appropriate line and click the Edit [image] button to open the Column Handling dialog. To change the default Handling settings, click the Edit Default button.


Hex Compare Settings

Session > Session Settings

Specs

These settings control which files to compare.

Comparison

These settings control how the files are compared.

Complete will align the bytes using a complex algorithm. Fast will perform a simpler but quicker alignment that is ideal for really large files. None will just align the bytes one by one.

Bytes per line controls the layout of the bytes in the view.

Files up to this size are loaded without file locks allows smaller files to be edited in other programs.


MP3 Compare Settings

Session > Session Settings

Specs

These settings control which files to compare.

Importance

These settings control which differences you consider important.


Picture Compare Settings

Session > Session Settings

Specs

These settings control which files to compare.

Format

Specify the file format to be used when reading the left and/or right files. The default selection is Detected, which means the file format will be selected based on file masks.

Comparison

These settings control how the files are compared. Many of them can also be changed using toolbar buttons. See the Picture Compare Overview topic for details on the difference modes.


Registry Compare Settings

Session > Session Settings

Specs

These settings control which files to compare.

Importance

These settings control which differences you consider important.


Version Compare Settings

Session > Session Settings

Specs

These settings control which files to compare.

Importance

These settings control which differences you consider important.


File Format Management

Tools > File Formats

From the Tools menu, choose File Formats [image]. Here you can see and manage the entire list of file formats.

The order of the list is important. When Beyond Compare looks for a file format to use on a file, it scans this list from top to bottom, stopping on the first enabled item whose mask matches the filename. To change the order of the list, highlight an item and click Move Up [image] or Move Down [image]. To enable or disable an item, mark or unmark its checkbox.

An item is colored red if any filename it could match is already matched by an item higher in the list. A disabled item is colored gray. An item with an empty mask cannot match any filename. To use any of these file formats, you must manually pick them in file sessions.

Note A specific session can independently enable or disable file formats. (See Folder Compare Miscellaneous Settings.) This way you can have a special file format that is used only by one session.

See also

Text Format Settings

Data Format Settings

Picture Format Settings


Text Format Settings

Text formats are file formats used by the Text Compare and Text Merge session types.

Click the tab containing the settings you want to edit:

General

Conversion

Grammar

Misc


Text Format General Settings

Text Format > General

The Mask is a set of file types to be associated with this file format.

The Description can include any text you want. The built-in file format descriptions include any limitations or requirements for using them.


Text Format Conversion Settings

Text Format > Conversion

The Conversion tab defines how files should be loaded and saved.

Text Compare sessions can compare plain text files, such as programming source files, directly. To compare files with structured or proprietary formats, it may be necessary to first extract the plain text content from the file. For example, Microsoft Word documents are binary files, but Beyond Compare can extract and compare their textual content. Beyond Compare can highlight differences in words and sentences but cannot identify differences in formatting or embedded images.

Select a Conversion method. When using External Program methods, you will need to specify a conversion program with the appropriate path and command line switches in the Loading field. In order to support filenames with extended characters, make sure to pick the appropriate filename encoding (Unicode or ANSI). The following variables will be replaced with the indicated information:

%s source file

%t target file

%n original file

%x original extension, including '.'

Conversion programs are only considered successful if they return a zero exit code and generate a non-empty file.

If you have a conversion program you want to use before saving, you can unmark the Disable editing checkbox and in the Saving field specify that conversion program's path and command line switches. The above variables apply.

Trim trailing whitespace and Convert leading spaces to tabs are edits that can be performed before saving files.

The Encoding of most text files can be detected automatically, but you can specify a specific code page to use.

The characters per line limit setting will break long lines at the indicated length. Those artificial line breaks are removed when saving an edited file.

Mark the Ctrl+Z indicates end of file checkbox for if your file type uses the hex value 1A as an EOF marker.


Text Format Grammar Settings

Text Format > Grammar

The Grammar tab defines the syntax of a file. Grammar elements such as comments and keywords are defined here. Each grammar element can be described by one or more grammar items which appear in the list. The order of the list is significant. Items higher on the list take precedence over lower items. See Editing a Grammar Item.

Line weights are used to improve alignment in a comparison. The alignment algorithm will try to line up matching lines with higher line weights.


Text Format Miscellaneous Settings

Text Format > Misc

Insert spaces instead of tabs

When disabled, pressing the Tab key inserts a tab character into the file. When enabled, an appropriate number of spaces is inserted instead.

The Tab stop setting determines the interval between tab stops. Pressing the Tab key advances the cursor to the next tab stop.

Mark the Lines are independent checkbox when each line is an independent record and it is not useful to manipulate consecutive difference lines as a section.

Mark the Column-based data checkbox when the position of each character on a line is important and lines should be compared column-by-column.


Data Format Settings

Data formats are file formats used by the Data Compare session type.

Click the tab containing the settings you want to edit:

General

Conversion

Type


Data Format General Settings

Data Format > General

The Mask is a set of file types to be associated with this file format.

The Description can include any text you want. The built-in file format descriptions include any limitations or requirements for using them.


Data Format Conversion Settings

Data Format > Conversion

The Conversion tab defines how files should be loaded and saved.

Data Compare sessions can compare plain text files, such as comma separated value files, directly. To compare files with structured or proprietary formats, it may be necessary to first extract the plain text content from the file. For example, Microsoft Excel spreadsheets are binary files, but Beyond Compare can extract and compare their textual content. Beyond Compare can highlight differences in words and sentences but cannot identify differences in formatting or embedded images.

Select a Conversion method. When using External Program methods, you will need to specify a conversion program with the appropriate path and command line switches in the Loading field. In order to support filenames with extended characters, make sure to pick the appropriate filename encoding (Unicode or ANSI). The following variables will be replaced with the indicated information:

%s source file

%t target file

%n original file

%x original extension, including '.'

Conversion programs are only considered successful if they return a zero exit code and generate a non-empty file.

If you have a conversion program you want to use before saving, you can unmark the Disable editing checkbox and in the Saving field specify that conversion program's path and command line switches. The above variables apply.

The Encoding of most text files can be detected automatically, but you can specify a specific code page to use.

Mark the Ctrl+Z indicates end of file checkbox for if your file type uses the hex value 1A as an EOF marker.


Data Format Type Settings

Data Format > Type

The Type tab defines the syntax of the data file.

Delimited text files

Select Delimited if the fields are separated by a delimiter character such as a tab or comma.

Mark the Detect checkbox to have the program automatically determine the delimiter. Otherwise, specify the delimiter character(s) and select the Text qualifier that optionally surrounds fields (necessary for data that contains the delimiter character).

Mark the Treat consecutive delimiters as one checkbox if a delimiter can consist of multiple delimiter characters. For example, if the data file contains columns separated by whitespace, you should enable this option and select Space as the delimiter character.

Unmark the Treat surrounding whitespace as part of delimiter checkbox if any whitespace next to a delimiter should be considered part of the data field.

Fixed position text files

Select Fixed for files where fields are defined by position on the line.

Enter the Column widths in a list separated by semicolons.

All types

Select the Decimal symbol to be used when interpreting numeric fields. Normally the symbol set by your system's Regional Settings is used but you can override it here.

Often, the first line of a data file is a header, containing the names of the columns. The First line contains option controls whether the first line is a header or a regular data row. Select Detect to have Data Compare try to determine it automatically.


Picture Format Settings

Picture formats are file formats used by the Picture Compare session type.

Click the tab containing the settings you want to edit:

General

Conversion


Picture Format General Settings

Picture Format > General

The Mask is a set of file types to be associated with this file format.

The Description can include any text you want. The built-in file format descriptions include any limitations or requirements for using them.


Picture Format Conversion Settings

Picture Format > Conversion

The Conversion tab defines how files should be loaded.

Select a Conversion method. When using External Program methods, you will need to specify a conversion program with the appropriate path and command line switches in the Loading field. In order to support filenames with extended characters, make sure to pick the appropriate filename encoding (Unicode or ANSI). The following variables will be replaced with the indicated information:

%s source file

%t target file

%n original file

%x original extension, including '.'

Conversion programs are only considered successful if they return a zero exit code and generate a non-empty file.


FTP Profile Management

Tools > FTP Profiles

From the Tools menu, choose FTP Profiles. Here you can see and manage the entire list of FTP Profiles.

Edit the <default> to change settings used for most profiles. You can edit specific profiles to have settings different from the default.

Click the tab for the settings you wish to edit:

General

Connection

Listings

Transfer

Authentication


FTP General Settings

Tools > FTP Profiles > General

These settings control general FTP behavior.

Login settings:

Protocol

Specify FTP or one of the secure FTP options: SSL or SSH.

Port

Override if you don't want to use the standard value for the specified protocol.

Host, Username, Password

Specify login parameters for your account.

Anonymous login

Mark to use an email address for your password.

Save password

Mark to weakly encrypt your password and store it along with other FTP profile settings.

Server settings:

Filenames are case sensitive

Mark to require filename character case to be the same in order to line up in the comparison.

Encoding

Specify the character encoding the server uses for directory listings and commands.

Time zone

Specify the time zone of the server. Timestamps will be converted to local time automatically.

Custom login commands

Specify any additional commands to send to the server upon connection. Not supported by SFTP (SSH) connections.

Note If you need help with the settings on this page, consult your system administrator.


FTP Connection Settings

Tools > FTP Profiles > Connection

These settings control how the connection is made to the remote server.

Connection:

Simultaneous connections

Specify the maximum number of concurrent connections (from 1 to 10) that Beyond Compare can create to this server.

Read timeout (seconds)

Specify the timeout for downloading files. The operation will fail if no bytes are received within this time.

Passive transfers (PASV)

Some firewall configurations require this setting, which modifies the methods used to transfer data back and forth between your computer and the FTP server. Not all FTP servers support PASV mode. If the connection hangs, try turning this on.

Limit ports used for active transfers (PORT)

Specify a range of ports that the FTP server will connect to when uploading/downloading files using active transfers (Passive transfers is disabled). Use this if you need to configure your firewall to allow incoming connections.

Use HOST before login

Controls whether the HOST command should be sent before sending the username and password to log in. This is required to connect to some virtual FTP hosts. Disable it if the connection is being dropped before the username is sent.

Clear control channel (SSL only)

After sending encrypted login details, control channel communication is unencrypted. Try turning this on if the initial SSL connection succeeds but file transfers or directory listings hang.

Clear data channel (SSL only)

Send file content and directory listings unencrypted. This can provide a speedup when transferring lots of files after sending encrypted login details.

Proxy:

Use proxy

Mark if connections should use FTP Proxy protocol. If you are not on a Local Area Network (LAN) or Wide Area Network (WAN), leave this option unchecked.

Proxy type

Specify the type of firewall.

Host, Port, Username, Password

Specify login parameters for your firewall / proxy.

Note If you need help with the settings on this page, consult your system administrator.


FTP Listing Settings

Tools > FTP Profiles > Listings

Beyond Compare parses the plain text directory listings sent from the FTP server in order to determine the remote folder structure. Unfortunately, there is no one standard for these listings.

These settings help Beyond Compare understand the conventions and capabilities of the FTP server.

LIST options:

Use MLSD command

Mark to request high-resolution timestamps from the server. If successful, the following settings are ignored. Soft links will be listed as plain files and directories, and listings won't be recursive.

Show hidden [-a]

Mark to make the FTP server include files that it wouldn't normally include, such as UNIX filenames that begin with a period.

Force long format [-l]

Mark to attempt to change the output of the FTP server list command. Try this option if Beyond Compare doesn't list any files when it loads.

Complete timestamps [-T]

Mark to expand the timestamps that the FTP server returns to include a full date and time, including seconds.

Resolve links [-L]

Mark to make the FTP server list soft links as plain files and directories with the timestamp and size of the link's target.

Recursive [-R]

Mark to make directory listings recursive, including contents of the subdirectories in response to a single FTP list command. Recursive listings may be slower initially, but save time overall if subdirectories will need to be examined eventually.

Link resolution:

FTP sites can connect files together using symbolic "links" which point from one area of the site to another. These links do not specify whether they point to files or folders, so the following methods of resolving are available:

Fast

Mark to treat any link which has an extension (eg. '.txt') as a file and all others as folders. This requires no extra transfers.

Simple

Mark to attempt to change directories into every link as it encounters it. If it succeeds the link is considered a folder, otherwise it is considered a file.

Miscellaneous settings:

Fetch incomplete timestamps

Mark to try to fetch the file's last modified time in cases where the directory listing only reports the date. This will provide more accurate timestamp comparisons at the cost of some performance. Not supported on all FTP servers.

Hide VMS versions

Mark to only include the most recent version of a file and align it with a local file. Otherwise, all versions of the file are included with their version numbers.

Note If you need help with the settings on this page, consult your system administrator.


FTP Transfer Settings

Tools > FTP Profiles > Transfer

These settings control how files are transferred to and from the FTP server.

Transfer settings:

Preserve timestamps on upload

Mark to force the remote timestamp to match the source timestamp. Only unmark if it causes problems with the server.

Compress transfers (MODE Z)

Mark to use compression to speed up transfers when supported by the server. This may actually slow down transfers on fast connections.

Force faster uploads to older OpenSSH servers

Mark to use larger transfer buffers and pipelining on OpenSSH servers prior to OpenSSH 3.9. This can substantially increase transfer speed, but is not compatible with all servers, and failures may not be obvious. Use a binary content comparison to verify the first transfers you do after enabling this.

Limit download (Kbps), Limit upload (Kbps)

Specify how much bandwidth Beyond Compare can consume for each connection.

Transfer type:

FTP sites can transfer data in two ways: ASCII and Binary. ASCII is used to transfer text files which don't have any special characters. The FTP server will automatically make any adjustments to line endings needed in ASCII mode. ASCII mode also handles transfers from mainframes by converting from EBCDIC to ANSI and adding line terminators to the end of records. Binary is used to transfer all other files, including pictures, music, Word documents, etc. In Binary mode, no changes are made to the file during the transfer.

Setting the transfer type to either ASCII or Binary will force all files to transfer that way. If the transfer type is Auto, Beyond Compare will automatically switch back and forth based on the file's extension. To change which files get transferred as ASCII, add and remove extensions from the ASCII types list.

Note If you need help with the settings on this page, consult your system administrator.


FTP Authentication Settings

Tools > FTP Profiles > Authentication

These settings apply globally to all profiles.

Anonymous logins:

Email address

When connecting to anonymous FTP sites, it is customary to include your email address as the password. Specify the email address (real or fictitious) to use for anonymous logins.

SSH public key authentication:

These settings are used to authenticate against an SSH server using a public/private key pair. Keys stored using OpenSSH's ssh-agent and PuTTY's pageant SSH agents will be used automatically.

Private key file

Specify the path to the SSH private key. OpenSSH, SSH.COM, PuTTY, and PGP key formats are supported.

Passphrase

Specify the passphrase used to encrypt the private key.

Create Keys

Click to create a new SSH key pair.

SSL client certificate:

This setting is used to authenticate against an SSL FTP server using an SSL client certificate.

Create Certificate

Click to create a new self-signed SSL client certificate.

Note If you need help with the settings on this page, consult your system administrator.


Source Control Integration

Tools > Source Control Integration

You can associate folders with your SCC-compatible source control application so that Beyond Compare can offer check out and check in services.


Where Settings are Stored

Where Settings are Stored on your Computer

Beyond Compare stores your sessions, customized file formats and other preferences as .xml files in its settings folder. A quick way of finding this location is to select Support from the Help menu and click the Explore settings folder link at the bottom of the dialog.

Standard installation

In Linux, the settings folder is:

$HOME/.beyondcompare/

In Windows, the settings folder is inside your Application Data folder. The location depends on your version of Windows. For instance, under Windows Vista the settings folder is:

C:\Users\<username>\AppData\Roaming\Scooter Software\Beyond Compare 3

Notice that this location differs for different users on the same computer.

Portable installation

If you prefer a more portable installation with the program and settings all in one location, you can copy your setting files to the same folder as the program. That folder may be the default program folder ("C:\Program Files\Beyond Compare 3"), or perhaps a folder on a USB flash drive or a CD-ROM. Portable installs allow you to share one set of settings for all users on a computer, or take your settings with you. If you don't have existing settings files to copy, you can create an empty file named BCState.xml in the folder.


Commands Reference

This part of the documentation describes the commands available in menus and on the toolbar for each view type.

Commands that are common to all views

Folder Compare Commands

Folder Sync Commands

Text Compare Commands

Text Merge Commands

Data Compare Commands

Hex Compare Commands

MP3 Compare Commands

Picture Compare Commands

Registry Compare Commands

Version Compare Commands

Text Edit Commands


Common Commands

The main menu changes depending on what kind of view is active. However, the commands listed below are common across different view types.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

New Session | Opens a new view with an empty session of the specified type.
New Tab | Opens a new tab in the current window and displays the Home view.
New Window | Opens a new window and displays the Home view.
Open Session | Opens a new view and displays the Home view.
Load Workspace | Lists saved workspaces. Selecting one closes any open views and restores the selected configuration.
Load Workspace > Manage Workspaces | Lets you rename or delete saved workspaces.
Save Workspace As | Saves the current configuration of windows and tabs as a named workspace.
Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Edits session-specific settings for the current session.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty session of the same type, with default settings.
Close Tab | Closes the current tab.
Exit | Quits Beyond Compare, prompting to save any edits. All of the instance's windows will close.

The Tools menu:

Options | Opens the Options dialog to set program preferences.
File Formats | Opens the File Formats dialog to manage file format settings.
FTP Profiles | Opens the FTP Profiles dialog to manage FTP settings.
Source Control Integration | Opens the Source Control Integration dialog. Available in Windows version only.
Tweaks * | Opens the Tweaks dialog to set obscure program options.
Customize Commands | Opens the Customize Commands dialog that controls keyboard shortcuts and visibility of commands on menus and toolbars.
Export Settings | Opens the Export Settings dialog to selectively save settings and sessions to a file.
Import Settings | Opens the Import Settings dialog to selectively load settings and sessions from a file.
Save Snapshot | Opens the Save Snapshot dialog to create a snapshot of a folder structure.
Edit Text File | Opens a new Text Edit view.

The Help menu:

Contents | Displays help contents.
Context Sensitive Help | Displays help contents page relevant to what you are focused on.
Scooter Software on the Web | Opens the Scooter Software website in your browser.
Check for Updates | Checks to see if a newer version of Beyond Compare is available.
Support | Displays resources for getting support.
Enter Key | Opens the Register dialog to accept your license key.
About Beyond Compare | Displays the About box with program version and license information.

* Hidden by default.


Folder Compare Commands

Following is a description of the Folder Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Folder Compare Session Settings dialog.
Clear Session | Replaces the current view with an empty Folder Compare.
Swap Sides | Exchanges the left and right base folders.
Back | Goes back to (earlier) compared base folders.
Forward | Goes forward to (later) compared base folders.
Browse for Folder > Left Side / Right Side | Browses for an existing folder on the specified side.
Up One Level > Left Side / Right Side / Both Sides | Changes either or both base folders to their parent folders.
Folder Compare Report | Produces a Folder Compare report.
Folder Compare Info | Displays comparison statistics.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the current base folders.
Sync Base Folders | Opens a new Folder Sync session based on the current base folders.

The Actions menu:

Open Folder / Close Folder | Opens or closes the selected folder in the comparison.
Open Subfolders | Opens the selected folders and all their subfolders.
Close Subfolders * | Closes the selected folders and all their subfolders.
Set as Base Folder | Sets the selected folder as the base folder on its side of the comparison.
Set as Base on Other Side | Sets the selected folder as the base folder on the other side of the comparison.
Set as Base Folders | Sets the two selected folders as the left and right base folders in this comparison view. (To open them in a new view use Open in New View instead.)
Open | Opens selected items in a new comparison view. If the items are files, the view type is determined by the file format list. If exactly two items are selected, they will be compared to each other (whether or not they are across from each other) in the new view. If only one item is selected it will be compared to the item across from it, if it exists.
Open With | Opens selected files in a new view using a specified type of file session, or opens the selected items in an external application, as defined in "Open With" Applications. Note that the Folder Compare view is not automatically updated if the items are modified by the external application.
Open With > Associated Application | Opens selected files with the associated application.
Open With > Text Edit | Opens selected files with the built-in text editor.
Quick Compare | Displays the Quick Compare dialog for the selected files. If exactly two files are selected, they will be compared to each other (whether or not they are across from each other). If only one file is selected, it will be compared to the file across from it.
Compare To | Allows you to select one item, and then click on a second item to compare them in a new view.
Align | Forces selected items to be side-by-side. Items' parent folders must be side-by-side.
Align With | Allows you to select one item, and then click on a second item to force them to be side-by-side.
Compare Contents | Compares contents of the selected items using one of three methods.
Copy to Other Side | Dynamic command that copies selected files, folders to the opposite side. The caption and icon appear as Copy to Right, Copy to Left or Copy to Side depending on which side(s) are selected.
Copy to Right / Copy to Left * | Copies selected files, folders to the explicitly indicated side. Normally associated with Ctrl+R, Ctrl+L keyboard shortcuts.
Copy to Side * | Prompts which side to copy selected files, folders to.
Move to Other Side | Dynamic command that moves selected files, folders to the opposite side. The caption and icon appear as Move to Right, Move to Left or Move to Side depending on which side(s) are selected.
Move to Right / Move to Left * | Moves selected files, folders to the explicitly indicated side.
Move to Side * | Prompts which side to move selected files, folders to.
Copy to Folder | Copies selected files, folders to another folder.
Move to Folder | Moves selected files, folders to another folder.
Delete | Deletes selected files, folders.
Rename | Renames selected files, folders.
Attributes | Changes file attributes on selected files, folders.
Touch | Changes timestamps on selected files, folders.
Exclude | Excludes selected file, or type of file, from the current session.
New Folder | Creates a new folder.
Copy Filename | Copies a list of the selected items' paths to the clipboard.
Ignored | Suppresses differences in selected items.
Refresh Selection | Refreshes the selected items.
File Compare Report | Produces a File Compare report for the selected files.
Synchronize > Update Right | Copies newer and orphan items from left to right.
Synchronize > Update Left | Copies newer and orphan items from right to left.
Synchronize > Update Both | Performs a bidirectional update by copying newer and orphan items from left to right and from right to left.
Synchronize > Mirror to Right | Replaces all different items on right, deletes any right-side orphans, and copies any left-side orphans to the right.
Synchronize > Mirror to Left | Replaces all different items on left, deletes any left-side orphans, and copies any right-side orphans to the left.
Source Control | Displays a submenu of source control actions (see below). Only appears if a source control provider has been configured and all selected items are under source control.
Explorer | Displays the file manager's context menu for the selected item(s).

Source Control Submenu:

Add to source control | Adds the file to the project.
Remove from source control | Removes the file from the project.
Get latest version | Gets the latest version from the source control repository.
Get * | Gets a particular version from the source control repository.
Check in | Takes your changes and applies them to the project.
Check out | Checks the file out from the source control repository and makes your local copy writable.
Undo check out | Removes any changes you have made to the local copy and sets it back to read-only.
Show differences | Tells the version control system to display the comparison of the file with the one in version control. The version control system will only use Beyond Compare if it is set up to do so.
Show history | Shows the history of the file in the version control system.
Show properties | Shows version control-specific properties.
Run source control application | Runs the source control application.

The Edit menu:

Expand All | Opens all folders in view.
Collapse All | Closes all folders in view.
Select All | Selects all visible items.
Select All Files | Selects all visible files.
Select Newer > Left Side / Right Side / Both Sides | Selects all visible files that are newer on the specified side.
Select Orphans > Left Side / Right Side / Both Sides | Selects all visible orphan files on the specified side.
Invert Selection | Selects all items not currently selected, and deselects all items currently selected.
Refresh | Refreshes open folders.
Full Refresh | Refreshes entire comparison.

The Search menu:

Next Difference | Positions at next difference.
Previous Difference | Positions at previous difference.
Find Filename | Finds filename matching search string.
Find Next Filename | Finds next filename matching search string.
Find Previous Filename | Finds previous filename matching search string.

The View menu:

Show All | Uses no display filter on either side.
Show Differences | Filters out matches, based on file status, from both sides.
Show Same | Filters out older, newer or different, and orphans from both sides.
Show No Orphans | Filters out orphans from both sides.
Show Differences but No Orphans | Filters out matches and orphans from both sides.
Show Orphans | Filters out matches, older, and newer or different from both sides.
Show Left Newer | Filters out matches, orphans, older on left (newer or different on right) from both sides.
Show Right Newer | Filters out matches, orphans, newer or different on left (older on right) from both sides.
Show Left Newer and Left Orphans | Filters out matches and older on left (newer or different on right) from both sides and orphans on the right side.
Show Right Newer and Right Orphans | Filters out matches and newer or different on left (older on right) from both sides and orphans from the left side.
Show Left Orphans | Filters out matches, older, and newer or different from both sides and orphans on the right side.
Show Right Orphans | Filters out matches, older, and newer or different from both sides and orphans on the left side.
Show None * | Hides all files. Useful in conjunction with Always Show Folders to copy folder structures.
Always Show Folders | Shows all folders, except those excluded by file filters.
Compare Files and Folder Structure | Shows folders containing files or folders that match the current display filter. Orphan folders will follow the same filtering rules as orphan files.
Compare Files Only | Shows only folders containing files to be shown.
Ignore Folder Structure | Compares filenames regardless of which subfolder they may be in. (Also called Flatten Folders.)
Suppress Filters | Temporarily suppresses file filters and display filters.
Ignore Unimportant Differences | Treats unimportant differences as same.
Columns | Shows or hides view columns.
Legend | Displays a window that lists what the different folder colors mean.
Show Log | Shows or hides the log panel.

* Hidden by default.


Folder Sync Commands

Following is a description of the Folder Sync commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Folder Sync Session Settings dialog.
Clear Session | Replaces the current view with an empty Folder Sync.
Swap Sides | Exchanges the left and right base folders.
Folder Sync Info | Displays sync statistics.
Run Sync | Performs all sync actions.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the current base folders.
Compare Base Folders | Opens a new Folder Compare session based on the current base folders.

The Actions menu:

Open Folder / Close Folder | Opens or closes the selected folder in the comparison.
Open Subfolders | Opens the selected folders and all their subfolders.
Close Subfolders * | Closes the selected folders and all their subfolders.
Set as Base Folder | Sets the selected folder as the base folder on its side of the comparison.
Set as Base on Other Side | Sets the selected folder as the base folder on the other side of the comparison.
Set as Base Folders | Sets the two selected folders as the left and right base folders in this comparison view. (To open them in a new view use Open in New View instead.)
Open | Opens selected items in a new comparison view. If the items are files, the view type is determined by the file format list. If exactly two items are selected, they will be compared to each other (whether or not they are across from each other) in the new view. If only one item is selected it will be compared to the item across from it, if it exists.
Open With | Opens selected files in a new view using a specified type of file session, or opens the selected items in an external application, as defined in "Open With" Applications. Note that the Folder Sync view is not automatically updated if the items are modified by the external application.
Open With > Associated Application | Opens selected files with the associated application.
Open With > Text Edit | Opens selected files with the built-in text editor.
Exclude | Excludes selected file, or type of file, from the current session.
Copy Filename | Copies a list of the selected items' paths to the clipboard.
Refresh Selection | Refreshes the selected items.
Explorer | Displays the file manager's context menu for the selected item(s).

The Edit menu:

Expand All | Opens all folders in view.
Collapse All | Closes all folders in view.
Select All | Selects all visible items.
Invert Selection | Selects all items not currently selected, and deselects all items currently selected.
Refresh | Refreshes open folders.
Full Refresh | Refreshes entire comparison.

The Search menu:

Next Conflict | Positions at next conflict.
Previous Conflict | Positions at previous conflict.
Find Filename | Finds filename matching search string.
Find Next Filename | Finds next filename matching search string.
Find Previous Filename | Finds previous filename matching search string.

The View menu:

Peek | Temporarily shows items that will not be affected by the sync.
Ignore Unimportant Differences | Treats unimportant differences as same.
Columns | Shows or hides view columns.
Legend | Displays a window that lists what the different folder colors mean.
Show Log | Shows or hides the log panel.


Text Compare Commands

Following is a description of the Text Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Text Compare Session Settings dialog.
Clear Session | Replaces the current view with an empty Text Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files, prompting to save first if necessary.
Recompare Files | Recompares the displayed files, preserving edits, but not undoability.
Text Compare Report | Produces the Text Compare report.
Text Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file viewer.
Merge Files | Opens a new Text Merge session based on the currently loaded files.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu:

Open File | Opens an existing file into the selected pane.
Open File on File System * | Opens an existing local file into the selected pane.
Open File on FTP Site * | Opens an existing file on an FTP site into the selected pane.
Open Clipboard | Loads the Clipboard contents into the selected pane.
Open with Text Edit | Opens the selected pane's file in the text editor.
Open With | Opens the selected pane's file in one of the external Open With applications.
Save File | Saves the modified file from the selected pane.
Save File As | Saves the file from the selected pane with a new name.
Save File on File System As * | Saves the file from the selected pane with a new name on the file system.
Save File on FTP Site As * | Saves the file from the selected pane with a new name on an FTP site.
Explorer | Displays the file manager's context menu for the file in the selected pane.
Check In | Appears if a source control provider has been configured and the file is under source control.
Check Out |
Undo Check Out |

The Edit menu:

Undo | Undoes previous action.
Redo | Redoes previously undone action.
Align With | Allows you to select one or more lines, and then click on a line on the other side to force them to be side-by-side.
Isolate | Realigns comparison so that selected lines are by themselves.
Copy to Right / Copy to Left * | Copies selected lines or current section to indicated side.
Copy to Other Side | Copies selected lines or current section to opposite side. The caption and icon appear as Copy to Right or Copy to Left depending on the current side.
Copy Line to Right / Copy Line to Left * | Copies current line to indicated side.
Copy Line to Other Side | Copies current line to other side. The caption and icon appear as Copy Line to Right or Copy Line to Left depending on the current side.
Increase Indent | Increases indentation of selected lines.
Decrease Indent | Decreases indentation of selected lines.
Cut / Copy / Paste / Delete | Standard editing commands.
Delete Line * | Deletes the current line.
Delete to Start of Line * | Deletes text from the current position to the beginning of the line.
Delete to End of Line * | Deletes text from the current position to the end of the line.
Delete Word * | Deletes the word at the current position.
Delete to Start of Word * | Deletes from the current position to the beginning of the word.
Delete to End of Word * | Deletes from the current position to the end of the word.
Insert Line Before * | Inserts a new blank line before the current line.
Insert Line After * | Inserts a new blank line after the current line.
Select All | Selects all visible lines in the current pane.
Select Section | Selects all lines in the current section.
Compare Selection to Clipboard | Compares the selected text with the contents of the clipboard in a new view.
Convert File > Trim Trailing Whitespace | Strips off spaces and tab characters at end of lines.
Convert File > Leading Spaces to Tabs | Replaces spaces at the beginning of lines with the appropriate number of tab characters (based on current tab stop setting).
Convert File > Tabs To Spaces | Replaces all tab characters with the appropriate number of space characters (based on current tab stop setting).
Convert File > Line Endings | Changes the line ending style on all lines. (Windows/DOS = CR+LF, Unix = LF only, Macintosh = CR only)
Full Edit | Toggles between full character mode editing (enabled) and Beyond Compare 2-like line mode (disabled) in the main file panes.

The Search menu:

Next Difference | Positions at next difference text.
Previous Difference | Positions at previous difference text.
Next Difference Section | Positions at next difference section (contiguous range of lines with differences).
Previous Difference Section | Positions at previous difference section.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Next Replacement | Positions at next replacement text.
Previous Replacement | Positions at previous replacement text.
Next Edit | Positions at the next edited line beyond the cursor.
Previous Edit | Positions at previous edited line before the cursor.
Find | Searches for matching text.
Replace | Replaces matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Go To | Positions at specified line and column.
Toggle Bookmark | Places a numbered marker on the current line of the comparison, numbered from 0 to 9.
Go To Bookmark | Repositions at the specified bookmark.
Clear Bookmarks | Removes all bookmarks from the comparison.

The View menu:

Show All | Shows all lines, with or without differences.
Show Differences | Shows only lines with differences.
Show Same | Shows only lines without differences.
Show None * | Hides all lines.
Show Context | Shows lines surrounding differences. The number of context lines can be set in Text View Options.
Ignore Unimportant Differences | Treats unimportant differences as same.
Ignored | Suppresses differences in selected lines or current section.
Visible Whitespace | Shows or hides visible spaces, tabs.
Line Numbers | Shows or hides line numbers.
Syntax Highlighting | Shows or hides syntax highlighting.
Display Font * | Selects the font to use in editor panes.
Side-by-side Layout | Arranges editor panes left and right of each other.
Over-under Layout | Arranges editor panes above and below each other.
Webpages | Shows or hides web browser panels that display the current files as webpages.
Thumbnail View | Shows or hides the thumbnail summary of changes at left of view.
Text Details | Shows or hides the text details panel at bottom of view.
Hex Details | Shows or hides the hexadecimal details panel at bottom of view.
Alignment Details | Shows or hides the alignment details panel at bottom of view.
Ruler | Shows or hides the line details ruler.
File Info | Shows or hides file information panels at the top of editor panes.

* Hidden by default.


Text Merge Commands

Following is a description of the Text Merge commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Text Merge Session Settings dialog.
Clear Session | Replaces the current view with an empty Text Merge.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files, prompting to save first if necessary.
Recompare Files | Recompares the displayed files, preserving edits, but not undoability.
Text Compare Info | Displays comparison statistics.
Compare to Output > Left Side / Center Side / Right Side | Opens the file on the indicated side and the output file in a new Text Compare session.

The File menu:

Open File | Opens an existing file into the selected pane.
Open File on File System * | Opens an existing local file into the selected pane.
Open File on FTP Site * | Opens an existing file on an FTP site into the selected pane.
Open Clipboard | Loads the Clipboard contents into the selected pane.
Open with Text Edit | Opens the selected pane's file in the text editor.
Open With | Opens the selected pane's file in one of the external Open With applications.
Save File | Saves the modified file from the selected pane.
Save File As | Saves the file from the selected pane with a new name.
Save File on File System As * | Saves the file from the selected pane with a new name on the file system.
Save File on FTP Site As * | Saves the file from the selected pane with a new name on an FTP site.
Explorer | Displays the file manager's context menu for the file in the selected pane.

The Edit menu:

Undo | Undoes previous action.
Redo | Redoes previously undone action.
Align With | Allows you to select one line, and then click on a second line to force them to be side-by-side.
Isolate | Realigns comparison so that selected lines are by themselves.
Conflict | Clears or sets conflict for selected lines or current section.
Take Left / Take Center / Take Right | Takes selected lines or current section from indicated side.
Take Left Then Right / Take Right Then Left | Takes selected lines or current section from left and right in the indicated order.
Take Left Line / Take Center Line / Take Right Line | Takes current line from indicated side.
Increase Indent | Increases indentation of selected lines.
Decrease Indent | Decreases indentation of selected lines.
Cut / Copy / Paste / Delete | Standard editing commands.
Delete Line * | Deletes the current line.
Delete to Start of Line * | Deletes text from the current position to the beginning of the line.
Delete to End of Line * | Deletes text from the current position to the end of the line.
Delete Word * | Deletes the word at the current position.
Delete to Start of Word * | Deletes from the current position to the beginning of the word.
Delete to End of Word * | Deletes from the current position to the end of the word.
Insert Line Before * | Inserts a new blank line before the current line.
Insert Line After * | Inserts a new blank line after the current line.
Select All | Selects all visible lines in the current pane.
Select Section | Selects all lines in the current section.
Compare Selection to Clipboard | Compares the selected text with the contents of the clipboard in a new view.
Full Edit | Toggles between full character mode editing (enabled) and Beyond Compare 2-like line mode (disabled) in the main file panes.

The Search menu:

Clear Conflict Section, Next | Clears conflict for current section and positions at next conflict section.
Next Conflict Section | Positions at next conflict section.
Previous Conflict Section | Positions at previous conflict section.
Next Difference | Positions at next difference text.
Previous Difference | Positions at previous difference text.
Next Difference Section | Positions at next difference section.
Previous Difference Section | Positions at previous difference section.
Next Left Taken / Next Right Taken | Positions at next range of lines where indicated side was taken.
Previous Left Taken / Previous Right Taken | Positions at previous range of lines where indicated side was taken.
Next Edit | Positions at the next edited line beyond the cursor.
Previous Edit | Positions at previous edited line before the cursor.
Find | Searches for matching text.
Replace | Replaces matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Go To | Positions at specified line and column.
Toggle Bookmark | Places a numbered marker on the current line of the comparison, numbered from 0 to 9.
Go To Bookmark | Repositions at the specified bookmark.
Clear Bookmarks | Removes all bookmarks from the comparison.

The View menu:

Show All | Shows unchanged, same change, left change, right change, different change and conflict lines.
Show Changes | Shows same change, left change, right change, different change and conflict lines.
Show Conflicts | Shows conflict lines.
Show Left Changes | Shows same change, left change, different change and conflict lines.
Show Right Changes | Shows same change, right change, different change and conflict lines.
Show Mergeable | Shows same change, left change, right change, and different change lines.
Show Unchanged | Shows unchanged lines.
Show None * | Shows no lines.
Show Context | Shows lines surrounding differences. The number of context lines can be set in Text View Options.
Ignore Unimportant Differences | Treats unimportant differences as same.
Ignore Same Changes | Treats same changes as same.
Favor Left Changes | Suppresses highlighting of left-only changes in output.
Favor Right Changes | Suppresses highlighting of right-only changes in output.
Ignored | Ignores (or un-ignores) differences in selected lines or current section.
Visible Whitespace | Shows or hides visible spaces, tabs.
Line Numbers | Shows or hides line numbers.
Syntax Highlighting | Shows or hides syntax highlighting.
Display Font * | Selects the font to use in editor panes.
Side-by-side Layout | Arranges editor panes left and right of each other.
Over-under Layout | Arranges editor panes above and below each other.
Detached Output Pane | Shows output pane in separate window.
Webpages | Shows or hides web browser panels that display the current files as webpages.
Thumbnail View | Shows or hides the thumbnail summary of changes at left of view.
Center Pane | Shows or hides center pane.
Text Details | Shows or hides the text details panel at bottom of view.
Hex Details | Shows or hides the hexadecimal details panel at bottom of view.
Ruler | Shows or hides the line details ruler.
File Info | Shows or hides file information panels at the top of editor panes.

* Hidden by default.


Data Compare Commands

Following is a description of the Data Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Data Compare Session Settings dialog.
Clear Session | Replaces the current view with an empty Data Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files, prompting to save first if necessary.
Recompare Files | Recompares the displayed files, preserving edits, but not undoability.
Data Compare Report | Produces the Data Compare report.
Data Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file viewer.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu:

New File | Opens an empty file into the selected pane.
Open File | Opens an existing file into the selected pane.
Open File on File System * | Opens an existing local file into the selected pane.
Open File on FTP Site * | Opens an existing file on an FTP site into the selected pane.
Open Clipboard | Loads the Clipboard contents into the selected pane.
Open with Text Edit | Opens the selected pane's file in the text editor.
Open With | Opens the selected pane's file in one of the external Open With applications.
Save File | Saves the modified file from the selected pane.
Save File As | Saves the file from the selected pane with a new name.
Save File on File System As * | Saves the file from the selected pane with a new name on the file system.
Save File on FTP Site As * | Saves the file from the selected pane with a new name on an FTP site.
Explorer | Displays the file manager's context menu for the file in the selected pane.

The Edit menu:

Undo | Undoes previous action.
Redo | Redoes previously undone action.
Copy to Right / Copy to Left * | Copies selected rows to indicated side.
Copy to Other Side | Copies selected rows to opposite side. The caption and icon appear as Copy to Right or Copy to Left depending on the current side.
Cut / Copy / Paste / Delete | Standard editing commands.
Insert | Inserts new row.
Edit | Toggles edit mode on current cell.
Select All | Selects all visible rows in the current pane.

The Search menu:

Next Difference Row | Positions at next difference row.
Previous Difference Row | Positions at previous difference row.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Next Edit | Positions at the next edited row beyond the cursor.
Previous Edit | Positions at previous edited row before the cursor.
Find | Searches for matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Go To | Positions at specified row and column.

The View menu:

Show All | Shows all rows, with or without differences.
Show Differences | Shows only rows with differences.
Show Same | Shows only rows without differences.
Show None * | Hides all rows.
Ignore Unimportant Differences | Treats unimportant differences as same.
Resize Columns to Fit | Makes columns wide enough for data to be fully visible.
Columns | Shows or hides columns.
Visible Whitespace | Shows or hides visible spaces, tabs.
Row Numbers | Shows or hides row numbers.
Display Font * | Selects the font to use to display file data.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
Thumbnail View | Shows or hides the thumbnail summary of changes at left of view.
Row Details | Shows or hides the row details panel at bottom of view.
File Info | Shows or hides file information panels at the top of panes.

* Hidden by default.


Hex Compare Commands

Following is a description of the Hex Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Hex Compare Session Settings dialog.
Clear Session | Replaces the current view with an empty Hex Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files.
Recompare Files | Recompares the displayed files without reloading.
Hex Compare Report | Produces the Hex Compare report.
Hex Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file viewer.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu:

Open File | Opens an existing file into the selected pane.
Open File on File System * | Opens an existing local file into the selected pane.
Open File on FTP Site * | Opens an existing file on an FTP site into the selected pane.
Open Clipboard | Loads the Clipboard contents into the selected pane.
Open with Text Edit | Opens the selected pane's file in the text editor.
Open With | Opens the selected pane's file in one of the external Open With applications.
Explorer | Displays the file manager's context menu for the file in the selected pane.

The Search menu:

Next Difference Bytes | Positions at next difference bytes.
Previous Difference Bytes | Positions at previous difference bytes.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Find | Searches for matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Go To | Positions at specified byte.

The View menu:

Show All | Shows all items, with or without differences.
Show Differences | Shows only items with differences.
Show Same | Shows only items without differences.
Show None * | Hides all items.
Current Byte Address | Shows current byte address.
Little Endian Values | Lists values treating the first byte as the least significant one.
Big Endian Values | Lists values treating the first byte as the most significant one.
Byte Addresses | Shows or hides byte addresses.
Display Font * | Selects the font to use to display file data.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
Thumbnail View | Shows or hides the thumbnail summary of changes at left of view.
File Info | Shows or hides file information panels at the top of panes.

* Hidden by default.


MP3 Compare Commands

Following is a description of the MP3 Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the MP3 Compare Session Settings dialog.
Clear Session | Replaces the current view with an empty MP3 Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files.
Recompare Files | Recompares the displayed files without reloading.
MP3 Compare Report | Produces the MP3 Compare report.
MP3 Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file viewer.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.
Play Both | Plays both audio tracks.

The File menu:

Open File | Opens an existing file into the selected pane.
Open File on File System * | Opens an existing local file into the selected pane.
Open File on FTP Site * | Opens an existing file on an FTP site into the selected pane.
Play | Plays audio track.
Open With | Opens the selected pane's file in one of the external Open With applications.
Explorer | Displays the file manager's context menu for the file in the selected pane.

The Edit menu:

Copy | Copies selection to the Clipboard.
Select All | Selects all visible items in the current pane.

The Search menu:

Next Difference Item | Positions at next difference item.
Previous Difference Item | Positions at previous difference item.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Find | Searches for matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.

The View menu:

Show All | Shows all items, with or without differences.
Show Differences | Shows only items with differences.
Show Same | Shows only items without differences.
Show None * | Hides all items.
Ignore Unimportant Differences | Treats unimportant differences as same.
Item Is Important | Marks selected item as important or unimportant.
Visible Whitespace | Shows or hides visible spaces, tabs.
Display Font * | Selects the font to use to display file data.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
Item Details | Shows or hides the item details panel at bottom of view.
File Info | Shows or hides file information panels at the top of panes.

* Hidden by default.


Picture Compare Commands

Following is a description of the Picture Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Picture Compare Session Settings dialog.
Clear Session | Replaces the current view with an empty Picture Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files.
Recompare Files | Recompares the displayed files without reloading.
Picture Compare Report | Produces the Picture Compare report.
Picture Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file viewer.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu:

Open File | Opens an existing file into the selected pane.
Open File on File System * | Opens an existing local file into the selected pane.
Open File on FTP Site * | Opens an existing file on an FTP site into the selected pane.
Open Clipboard | Loads the Clipboard contents into the selected pane.
Open With | Opens the selected pane's file in one of the external Open With applications.
Explorer | Displays the file manager's context menu for the file in the selected pane.

The Edit menu:

Copy

Copies selection to the Clipboard.

The Search menu:

Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)

The View menu:

Tolerance Mode | Detects pixel differences greater than configurable tolerance.
Mismatch Range Mode | Measures degree of pixel difference.
Binary Operation Mode | Performs binary operation.
Blend Mode | Blends images based on configurable percentage.
Ignore Unimportant Differences | Treats unimportant differences as same.
Stretch to Same Size | Forces pictures to have same height and width.
Rotate Clockwise | Spins current picture to right by 90 degrees.
Rotate Counterclockwise | Spins current picture to left by 90 degrees.
Flip Horizontally | Swaps pixels of current picture relative to its horizontal center.
Flip Vertically | Swaps pixels of current picture relative to its vertical center.
Reset Difference Offset | Realigns top left corner of both pictures.
Difference Side-by-side Layout | Arranges panes left and right of each other with difference pane in middle.
Difference Over-under Layout | Arranges panes above and below each other with difference pane in middle.
Difference Underneath Layout | Arranges difference pane below left and right panes.
Only Difference Layout | Shows difference pane and hides left and right panes.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
File Info | Shows or hides file information panels at the top of panes.
Zoom > Zoom In | Makes pictures appear to be larger.
Zoom > Zoom Out | Makes pictures appear to be smaller.
Zoom > AutoZoom | Makes pictures appear to fill panes.

* Hidden by default.


Registry Compare Commands

Following is a description of the Registry Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Registry Compare Session Settings dialog.
Clear Session | Replaces the current view with an empty Registry Compare.
Swap Sides | Exchanges the left and right registries.
Up One Level > Left Side / Right Side / Both Sides | Changes either or both base keys to their parent keys.
Reload | Reloads the displayed registries.
Recompare | Recompares the displayed registries without reloading.
Registry Compare Report | Produces the Registry Compare report.
Registry Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file viewer.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu:

Open | Opens a registry into the selected pane.
Open Registry * | Opens a live registry into the selected pane.
Open Registry File on File System * | Opens an existing local registry file into the selected pane.
Open Registry File on FTP Site * | Opens an existing registry file on an FTP site into the selected pane.
Open with Text Edit | Opens the selected pane's file in the text editor.
Open With | Opens the selected pane's file in one of the external Open With applications.
Explorer | Displays the file manager's context menu for the file in the selected pane.

The Edit menu:

Set as Base Keys | Sets selected keys as base keys.
Set Both as Base Keys | Sets selected key and key on other side as base keys.
Set as Base Key on Other Side | Sets selected key as base key on other side.
Undo | Undoes previous action.
Redo | Redoes previously undone action.
Copy to Right / Copy to Left * | Copies selected items to indicated side.
Copy to Other Side | Copies selected items to opposite side. The caption and icon appear as Copy to Right or Copy to Left depending on the current side.
New Key | Adds a new key.
New Value | Adds a new value.
Modify | Modifies current value.
Delete | Deletes selected items.
Rename | Renames current item.
Copy Key Name | Copies current key's name to Clipboard.
Export | Saves current key as registry file.
Export All | Saves all keys as registry file.
Select All | Selects all visible items in the current pane.

The Search menu:

Next Difference Item | Positions at next difference item.
Previous Difference Item | Positions at previous difference item.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Find | Searches for matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.

The View menu:

Show All | Shows all items, with or without differences.
Show Differences | Shows only items with differences.
Show Same | Shows only items without differences.
Show None * | Hides all items.
Expand All | Opens all items.
Collapse All | Closes all items.
Visible Whitespace | Shows or hides visible spaces, tabs.
Display Font * | Selects the font to use to display file data.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
Text Details | Shows or hides the text details panel at bottom of view.
Hex Details | Shows or hides the hexadecimal details panel at bottom of view.
File Info | Shows or hides file information panels at the top of panes.

* Hidden by default.


Version Compare Commands

Following is a description of the Version Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu:

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Version Compare Session Settings dialog.
Clear Session | Replaces the current view with an empty Version Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files.
Recompare Files | Recompares the displayed files without reloading.
Version Compare Report | Produces the Version Compare report.
Version Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file viewer.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu:

Open File | Opens an existing file into the selected pane.
Open File on File System * | Opens an existing local file into the selected pane.
Open File on FTP Site * | Opens an existing file on an FTP site into the selected pane.
Open With | Opens the selected pane's file in one of the external Open With applications.
Explorer | Displays the file manager's context menu for the file in the selected pane.

The Edit menu:

Copy | Copies selection to the Clipboard.
Select All | Selects all visible items in the current pane.

The Search menu:

Next Difference Item | Positions at next difference item.
Previous Difference Item | Positions at previous difference item.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Find | Searches for matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.

The View menu:

Show All | Shows all items, with or without differences.
Show Differences | Shows only items with differences.
Show Same | Shows only items without differences.
Show None * | Hides all items.
Ignore Unimportant Differences | Treats unimportant differences as same.
Item Is Important | Marks selected item as important or unimportant.
Visible Whitespace | Shows or hides visible spaces, tabs.
Display Font * | Selects the font to use to display file data.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
Item Details | Shows or hides the item details panel at bottom of view.
File Info | Shows or hides file information panels at the top of panes.

* Hidden by default.


Text Edit Commands

Following is a description of the Text Edit commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

From the Tools menu, select Customize Commands [image] to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The File menu:

New File | Opens an empty file.
Open File | Opens an existing file.
Open File on File System * | Opens an existing local file.
Open File on FTP Site * | Opens an existing file on an FTP site.
Open With | Opens file in one of the external Open With applications.
Save File | Saves the modified file.
Save File As | Saves the file with a new name.
Save File on File System As * | Saves the file with a new name on the file system.
Save File on FTP Site As * | Saves the file with a new name on an FTP site.
Explorer | Displays the file manager's context menu for the file.
Check In | Appears if a source control provider has been configured and the file is under source control.
Check Out |
Undo Check Out |

The Edit menu:

Undo | Undoes previous action.
Redo | Redoes previously undone action.
Increase Indent | Increases indentation of selected lines.
Decrease Indent | Decreases indentation of selected lines.
Cut / Copy / Paste / Delete | Standard editing commands.
Delete Line * | Deletes the current line.
Delete to Start of Line * | Deletes text from the current position to the beginning of the line.
Delete to End of Line * | Deletes text from the current position to the end of the line.
Delete Word * | Deletes the word at the current position.
Delete to Start of Word * | Deletes from the current position to the beginning of the word.
Delete to End of Word * | Deletes from the current position to the end of the word.
Insert Line Before * | Inserts a new blank line before the current line.
Insert Line After * | Inserts a new blank line after the current line.
Select All | Selects all visible lines.
Convert File > Trim Trailing Whitespace | Strips off spaces and tab characters at end of lines.
Convert File > Leading Spaces to Tabs | Replaces spaces at the beginning of lines with the appropriate number of tab characters (based on current tab stop setting).
Convert File > Tabs To Spaces | Replaces all tab characters with the appropriate number of space characters (based on current tab stop setting).
Convert File > Line Endings | Changes the line ending style on all lines. (Windows/DOS = CR+LF, Unix = LF only, Macintosh = CR only)

The Search menu:

Next Edit | Positions at the next edited line beyond the cursor.
Previous Edit | Positions at previous edited line before the cursor.
Find | Searches for matching text.
Replace | Replaces matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Find in Files | Finds search string in multiple files.
Go To | Positions at specified line and column.
Toggle Bookmark | Places a numbered marker on the current line of the comparison, numbered from 0 to 9.
Go To Bookmark | Repositions at the specified bookmark.
Clear Bookmarks | Removes all bookmarks from the comparison.

The View menu:

Visible Whitespace | Shows or hides visible spaces, tabs.
Line Numbers | Shows or hides line numbers.
Syntax Highlighting | Shows or hides syntax highlighting.
Display Font * | Selects the font to use in editor pane.
Webpages | Shows or hides web browser panel that displays the current file as a webpage.
File Info | Shows or hides file information panels at the top of editor panes.

* Hidden by default.


Command Line Reference

Command Line Parameters

Notice that each parameter should be enclosed in quotation marks if it might contain a space.

Note Linux users should use "bcompare" instead of "BCompare.exe".

Parameter | Meaning
Named Session | Opens the specified session in the appropriate view. For example: BCompare.exe "My Session"
Named Workspace | Opens the specified saved workspace. (see also Managing Workspaces) For example: BCompare.exe "My Special Workspace"
Pair of folders | Opens a new Folder Compare view with the specified base folders. For example: BCompare.exe "C:\Left Folder" "C:\Right Folder"
Pair of files | Opens the specified files in the associated file view. For example: BCompare.exe "C:\Left File.ext" "C:\Right File.ext"
3 files | Opens a Text Merge view with the specified files in the left, right, and center panes. For example: BCompare.exe C:\Left.ext C:\Right.ext C:\Center.ext
4 files | Opens a Text Merge view with the specified files in the left, right, center, and output panes. For example: BCompare.exe C:\Left.ext C:\Right.ext C:\Center.ext C:\Output.ext
Script file | Automatically executes a list of commands without using a view. For example: BCompare.exe "@C:\My Script.txt"
- | Opens stdin in the appropriate view. For example: dir | BCompare.exe -

Command Line Switches

Note Linux users should prefix the switches with "-" instead of "/".

Switch | Meaning
/? | Displays the command line documentation.
/automerge | Automatically merges files without user interaction unless conflicts are found.
/bds <filename> | Prompts to compare against previous revisions available in the CodeGear RAD Studio/Borland Developer Studio "__history" folders. Add to the IDE Tools menu with "/BDS $SAVE $EDNAME" as the parameters, or use the Beyond Compare IDE Expert from JED Software, available at www.jed-software.com.
/closescript | Closes the script window on completion. Overrides the Close when finished setting in Tools > Options > Scripts.
/edit | Opens a Text Edit view.
/expandall | Expands all subfolders during the initial folder comparison.
/favorleft /favorright | Draws non-conflicting changes in the output from the "favored" side without coloring or section lines. For ignored unimportant conflicts, changes are automatically taken from the "favored" side instead of the center.
/filters=<file masks> | Uses the specified name filter for the initial folder comparison. Separate multiple file masks with semi-colons. Surround the name filter with quotes if it contains spaces.
/force | Writes conflicts to the output with CVS-style markers if /automerge is present.
/fv=<type>, /fileviewer=<type> | Opens a new view of the specified type which can be any of: "Text Compare" "Text Merge" "Data Compare" "Hex Compare" "MP3 Compare" "Picture Compare" "Registry Compare" "Version Compare"
/iu, /ignoreunimportant | Turns on Ignore Unimportant Differences if /automerge is present.
/mergeoutput=<filename> | Explicitly specifies the merge output file.
/nobackups | Prevents the creation of backup files.
/qc=<type>, /quickcompare=<type> | Performs a quick comparison of two files and sets the DOS error level on exit. The specified type can be size, crc, or binary. If a type is not specified, a rules-based comparison will be performed. Error levels are documented below.
/reviewconflicts | Opens a Text Merge view if /automerge is present and conflicts are found.
/ro, /readonly | Disables editing on all sides.
/ro1, /lro, /leftreadonly /ro2, /rro, /rightreadonly | Disables editing on the respective side.
/savetarget=<filename> | Overwrites the specified file instead of original file when the file view's Save command is used.
/silent | Causes a script to be processed invisibly, bypassing the Task Bar entry and Scripting Status window. All interaction will be suppressed, so any unresolved issue that would normally show a dialog will log an error instead.
/solo | Forces a new instance of the program.
/sync | Opens a Folder Sync view.
/title1=<title>, /lefttitle=<title> /title2=<title>, /righttitle=<title> /title3=<title>, /centertitle=<title> /title4=<title>, /outputtitle=<title> | Shows the specified description in the respective path edit.
/vcs1=<path>, /vcsleft=<path> /vcs2=<path>, /vcsright=<path> /vcs3=<path>, /vcscenter=<path> /vcs4=<path>, /vcsoutput=<path> | Shows the specified version control system path in the respective path edit unless a title has been provided. For a file view, the specified path is also used to pick the appropriate file format.

DOS Error Levels set on exit

Level | Meaning
0 | Success
1 | Binary same
2 | Rules-based same
11 | Binary differences
12 | Similar
13 | Rules-based differences
14 | Conflicts detected
100 | Unknown error
101 | Conflicts detected, merge output not written
102 | BComp.exe unable to wait until BCompare.exe finishes
103 | BComp.exe cannot find BCompare.exe
104 | Trial period expired
105 | Error loading script file
106 | Script syntax error
107 | Script failed to load folders or files

Command Line Executable Files

Executable | Meaning
BCompare.exe | This is the main application. Only one copy will run at a time, regardless of how many windows you have open. If you launch a second copy it will tell the existing copy to start a comparison and exit immediately.
BComp.exe | This is a Win32 GUI program. If launched from a version control system, it should work just fine. If launched from a console window, the console (or batch file) will not wait for it.
BComp.com | This is a Win32 console program. It has to have a console. If you launch it from one (or a batch file) that console will wait for the comparison to complete before returning. If you launch it from a version control system interactively, it will show a console window while it's waiting.


Scripting Reference

A script is a simple text file containing a list of commands which can control the program and automatically perform file operations or produce reports. See also Automating with Scripts and Sample Scripts.

You can use lt in place of left or rt in place of right in any of the commands.

These are the script commands (in alphabetical order):

ATTRIB BEEP COLLAPSE COMPARE COPY COPYTO CRITERIA DATA-REPORT DELETE EXPAND FILE-REPORT FILTER FOLDER-REPORT HEX-REPORT LOAD LOG MOVE MP3-REPORT OPTION PICTURE-REPORT REGISTRY-REPORT RENAME SELECT SNAPSHOT SYNC TEXT-REPORT TOUCH VERSION-REPORT

ATTRIB

Usage:

attrib (+|-)<attribute set 1> [(+|-)<attribute set 2> [...]]

Where <attribute set> is:

[a][s][h][r]

The Linux version does not support attrib.

Sets (+) or clears (-) the DOS file attributes in the current selection. Use a for archive, s for system, h for hidden and r for read-only.

Examples:

attrib +h

attrib +sh -a

BEEP

Usage:

beep

Beeps the PC speaker. The beep occurs regardless of the /silent command line switch.

COLLAPSE

Usage:

collapse all

collapse <path 1> [<path 2> [...]]

Collapses all folders or folders with specified paths. Paths are relative to the base folder and can not have wildcards.

Example:

collapse "My Folder 1" "My Folder 2"

COMPARE

Usage:

compare [CRC|binary|rules-based]

Compares the contents of the current selection using the compare type. By default, the most recent compare type is used.

This command only compares files once. To change how files are compared after modification, use CRITERIA.

COPY

Usage:

copy (left->right|right->left)

Copies the selected files/folders in the direction indicated.

COPYTO

Usage:

copyto [left|right|all] [path:(relative|base|none)] <path>

Copies the selected files/folders on the specified side to the specified path using the path option.

· base keeps the entire folder structure relative to the base folders of all selected items.
· relative keeps the minimum relative folder structure of all selected items.
· The defaults are all and path:none.

CRITERIA

Usage:

criteria \

[attrib:<attribute set>] \

[version] \

[timestamp[:[<number of seconds>sec][;IgnoreDST]]] \

[size|CRC|binary|rules-based] \

[timezone:(ignore|(left|right)(+|-)<0..12>)] \

[follow-symlinks]

Where <attribute set> is:

[a][s][h][r]

The Linux version does not support attrib.

Sets all comparison criteria settings.

· attrib enables comparisons of the specified DOS file attributes. Use a for archive, s for system, h for hidden and r for read-only.
· version enables comparisons of version information common in exes and dlls.
· timestamp enables timestamp comparisons.
o <number of seconds>sec considers differences within a tolerance of seconds as matches.
o IgnoreDST considers differences of exactly 1 hour as matches.
· size, CRC, binary and rules-based are the possible ways to compare contents.
· timezone ignores timezone differences or applies timezone offset to the specified side.
· follow-symlinks treats symbolic links and NTFS junctions as the target file or folder, rather than the link itself.

Example:

criteria attrib:sh timestamp:2sec;IgnoreDST rules-based timezone:left+6

DATA-REPORT

Usage:

data-report \

layout:<layout> \

[options:<options>] \

[title:<report title>] \

output-to:(printer|clipboard|<filename>) \

[output-options:<options>] \

[<comparison>]

Generates a Data Compare report of the currently selected files.

· layout controls the report's appearance and can be side-by-side, summary or interleaved.
· options is optional and is used differently for each layout.
o ignore-unimportant treats differences in unimportant text as matches and is available in all layouts.
o display-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.
o line-numbers includes row numbers in the side-by-side layout.
· title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

DELETE

Usage:

delete [recyclebin=(yes|no)] (left|right|all)

Deletes the currently selected files/folders on the specified side(s). The recyclebin argument only has effect where supported by the operating system.

Windows does not recycle from network drives, FTP sites and archive files.

EXPAND

Usage:

expand all

expand <path 1> [<path 2> [...]]

Expands specified subfolders or all subfolders. Paths are relative to the base folder and can not have wildcards. Subfolders must be expanded in order for their contents to be used by other commands, like SELECT. expand all will not expand subfolders that have been excluded from the comparison by File Filter settings.

FILE-REPORT

Usage:

file-report \

layout:<layout> \

[options:<options>] \

[title:<report title>] \

output-to:(printer|clipboard|<filename>) \

[output-options:<options>] \

[<comparison>]

Generates a report of the currently selected files based on the type of files processed. For example, it will produce a DATA-REPORT for file types associated with a Data Compare file format.

· layout controls the report's appearance and can be side-by-side or summary.
· options is optional and is used differently for each layout.
o ignore-unimportant treats differences in unimportant text as matches and is available in all layouts.
o display-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.
o line-numbers includes line numbers in the side-by-side layout.
· title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

Example:

file-report layout:side-by-side options:display-mismatches &

output-to:printer output-options:print-color,wrap-word

FILTER

Usage:

filter <file masks>

filter cutoff:([<|>](<timestamp>|<number of days>[days])|none)

filter attrib:((+|-)<attribute set>|none)

filter size:([<|>]<number>[KB|MB|GB|TB]|none)

filter exclude-protected

filter include-protected

Where <attribute set> is:

[a][s][h][r]

The Linux version does not support attrib, exclude-protected or include-protected.

Controls which folders and types of files are compared by using name filtering (file masks), date filtering (cutoff) or other filtering (attrib, size, exclude-protected or include-protected).

· Name filters include and exclude files and folders based on their names and paths. Multiple masks can be separated by semicolons. To indicate that a mask is an exclude mask use a leading minus (-). To indicate that a mask affects folders use a trailing backslash (\).
· cutoff excludes all files older (<) or newer (>) than a timestamp or a number of days from the current system date (<number of days>days). By default, cutoff:< is used. none can be used to remove date filtering. The date parsing is fairly lenient but if you want to be sure it parses correctly, use the format specified by the operating system's regional settings. (See Control Panel > Regional and Language Settings.) The time is optional and should follow the date (cutoff:"12/31/2012 12:00pm"). Remember to use quotation marks (" ") whenever a term contains a space.
· attrib limits the comparison to files which have an included DOS file attribute (+) and don't have an excluded attribute (-). Use a for archive, s for system, h for hidden and r for read-only. none can be used to remove attribute filtering.
· size excludes all files smaller (<) or larger (>) than the given size. By default the size is given in bytes but you can add KB, MB, GB or TB to the end to indicate that the value is in kilobytes, megabytes, gigabytes or terabytes, respectively. none can be used to remove size filtering.
· exclude-protected excludes files and folders that have both system and hidden attributes set.
· include-protected includes files and folders that have both system and hidden attributes set.

Examples:

filter "*.pas;*.dpr;*.dfm"

filter cutoff:<7days

filter cutoff:>"Dec 31, 2012"

filter cutoff:"12/31/2012 12:00pm"

filter attrib:-sh

filter "*.txt;-My Folder\" attrib:+r

FOLDER-REPORT

Usage:

folder-report \

layout:<layout> \

[options:<options>] \

[title:<report title>] \

output-to:(printer|clipboard|<filename>) \

[output-options:<options>]

Generates a folder comparison report of the currently loaded base folders. Folders are shown in their current state. To include subfolders add an expand all command before this.

· layout controls the report's appearance and can be side-by-side, summary or xml.
· options is optional.
o Display filter flags control which files are included in the report. The possible values are display-all, display-mismatches, display-no-orphans, display-mismatches-no-orphans, display-orphans, display-left-newer, display-right-newer, display-left-newer-orphans, display-right-newer-orphans and display-matches. By default, display-all is used.
o Optional columns can be included, separated by commas, in the report by using the flags column-version, column-size, column-crc, column-timestamp, column-attributes, column-group, column-owner and column-vcs. By default, column-size and column-timestamp are included. column-none can be used by itself to clear the default columns.
· title, output-to and output-options arguments are documented under Common Report Arguments.

Examples:

folder-report layout:side-by-side &

options:column-size,column-version,column-timestamp &

output-to:clipboard output-options:html-color

folder-report layout:xml output-to:"C:\My Report.xml"

HEX-REPORT

Usage:

hex-report \

layout:<layout> \

[options:<options>] \

[title:<report title>] \

output-to:(printer|clipboard|<filename>) \

[output-options:<options>] \

[<comparison>]

Generates a Hex Compare report of the currently selected files.

· layout controls the report's appearance and can be side-by-side, summary or interleaved.
· options is optional and is used differently for each layout.
o display-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.
o line-numbers includes byte addresses in the side-by-side layout.
· title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

LOAD

Usage:

load <session>

load [create:(all|left|right)] <left path> [<right path>]

load <default>

Loads the specified Folder Compare session, the specified base folders or a new Folder Compare session with default settings (load <default>). Failure to load a base folder will cause the script to terminate.

· Loading a session causes all that session's settings, except the display filter (show all, only mismatches, only matches, etc.), to be used.
· Loading base folders uses the currently active settings. By default, the program defaults are used.
· The optional create parameter creates a base folder if it doesn't already exist.

Examples:

load "My Session"

load "C:\My Folder" "X:\Your Folder"

load <default>

LOG

Usage:

log [none|normal|verbose] [[append:]<filename>]

Controls how detailed the log is and where the log is stored.

· none, normal and verbose determine the amount of detail used in the log. Logging is initially disabled and begins when the mode is changed from none.
· append: causes logging to add to the file instead of replace it. By default, the log is output as Log.txt in the current directory (eg, the Windows "Start In" folder in shortcut properties).

MOVE

Usage:

move (left->right|right->left)

Moves the selected files/folders in the direction specified.

MP3-REPORT

Usage:

mp3-report \

layout:<layout> \

[options:<options>] \

[title:<report title>] \

output-to:(printer|clipboard|<filename>) \

[output-options:<options>] \

[<comparison>]

Generates a MP3 Compare report of the currently selected files.

· layout controls the report's appearance and can be side-by-side or summary.
· options is optional and is used differently for each layout.
o ignore-unimportant treats differences in unimportant text as matches and is available in all layouts.
o display-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.
· title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

OPTION

Usage:

option stop-on-error

option confirm:(prompt|yes-to-all|no-to-all)

Adjusts script processing options.

· stop-on-error makes the script watch for various error conditions, including file operation errors, and, when one occurs, prompts the user before continuing.
· confirm can use prompt, yes-to-all or no-to-all to handle confirmation dialogs that occur due to file operations. By default, prompt is used.

PICTURE-REPORT

Usage:

picture-report \

layout:<layout> \

[options:<options>] \

[title:<report title>] \

output-to:(printer|clipboard|<filename>) \

[output-options:<options>] \

[<comparison>]

Generates a Picture Compare report of the currently selected files.

· layout controls the report's appearance and can be side-by-side or summary.
· options is optional and is used differently for each layout.
o ignore-unimportant treats differences in unimportant text as matches in the summary layout.
· title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

REGISTRY-REPORT

Usage:

registry-report \

layout:<layout> \

[options:<options>] \

[title:<report title>] \

output-to:(printer|clipboard|<filename>) \

[output-options:<options>] \

[<comparison>]

Generates a Registry Compare report of the currently selected files.

· layout controls the report's appearance and can be side-by-side or summary.
· options is optional and is used differently for each layout.
o ignore-unimportant treats differences in unimportant text as matches and is available in all layouts.
o display-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.
· title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

RENAME

Usage:

rename [regexpr <old mask>] <new mask>

Performs a multi-file rename on the current selection using the specified new mask. regexpr uses an old mask to perform a "Regular Expression Rename". By default, a DOS-style rename is performed.

Examples:

rename *.bak

rename regexpr (...)(...)\.txt $2$1.txt

SELECT

Usage:

select <selection mask 1> [<selection mask 2> [...]]

Where <selection mask> is one of the following:

all

[(left|right|all).][(exact|diff|newer|older|orphan|all).][(files|folders|all)]

empty.folders

Select controls which files and folders can be operated on. Only files and folders that match at least one of the selection masks are part of the selection.

· left, right or all limits the selection to the specified side. By default, all is used.
· exact, diff, newer, older, orphan or all limits the selection based on results of comparison. diff refers to differences in criteria other than timestamps. To compare timestamps use newer or older instead. Folders must contain only the specified result type to be affected. By default, all is used.
· files, folders or all limits the selection to files, folders or both. By default, all is used.
· empty.folders is a special selection mask that will select empty folders.

Examples:

select all

select left

select exact

select files

select right.diff

select left.folders

select newer.files right.older.files

SNAPSHOT

Usage:

snapshot \

[save-crc] \

[save-version] \

[expand-archives] \

[follow-symlinks] \

[no-filters] \

left|right|path:<path> \

[output:<target>]

Saves a read-only snapshot of the specified folder.

· save-crc calculates CRC's for all files and stores them as part of the snapshot.
· save-version stores version information for executable files.
· expand-archives stores the contents of archive files in an expanded format.
· follow-symlinks stores files and folders pointed to by symbolic links.
· no-filters stores all files regardless of the active filename filters.
· left, right and path indicate which folder is stored. left or right will save a snapshot of one of the loaded base folders and path will save a snapshot of a specified path.
· output is optional and determines where the snapshot will be saved. By default, it will be saved in the current folder.
o If target is a fully qualified filename, that will be the name of the snapshot. If target doesn't have an extension, .bcss will be used.
o If the target isn't included or refers to a folder a filename will be generated based on the source folder's name and the current system date, eg folder_2012-12-31.bcss. If necessary an additional number will be added to the generated name to keep it from overwriting existing snapshots.

Examples:

snapshot save-crc save-version no-filters path:C:\ output:D:\

snapshot left output:"My Snapshot.bcss"

SYNC

Usage:

sync \

[visible] \

[create-empty] \

(update|mirror):(left->right|right->left|all)

Synchronizes folders by copying and deleting files. This command does not use the current selection.

· visible enables "Only affect visible files" behavior. Only files in expanded folders will be affected.
· create-empty enables the "Create empty folders" behavior.
· update copies newer and orphan files in the indicated direction, leaving orphans and newer files on the opposite side unchanged. Using all as the direction indicates a bidirectional sync and copies newer and orphan files in both directions.
· mirror makes the target folder identical to the source one. Newer, older, different and orphaned files are all copied to the destination. Orphans in the destination are deleted. The all direction doesn't apply in this context and is not valid.

Example:

sync create-empty mirror:left->right

TEXT-REPORT

Usage:

text-report \

layout:<layout> \

[options:<options>] \

[title:<report title>] \

output-to:(printer|clipboard|<filename>) \

[output-options:<options>] \

[<comparison>]

Generates a Text Compare report of the currently selected files.

· layout controls the report's appearance and can be side-by-side, summary, interleaved, patch, statistics or xml. Deprecated layouts over-under and composite have been replaced by interleaved.
· options is optional and is used differently for each layout.
o ignore-unimportant treats differences in unimportant text as matches and is available in all layouts.
o display-all, display-mismatches, display-context or display-matches can be used to control which lines of the comparison are included in all layouts except summary, patch and statistics. By default, display-all is used.
o line-numbers includes line numbers in the side-by-side layout.
o strikeout-left-orphans crosses out left only lines in the interleaved layout.
o strikeout-right-orphans crosses out right only lines in the interleaved layout.
o patch-normal, patch-context or patch-unified formats are available in the patch layout. By default, patch-normal is used.
· title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

The deprecated stats-descriptive option will generate a summary report instead and post a warning to the log. The deprecated stats-tabular option is ignored in the statistics layout: the statistics layout is always tabular (CSV) now.

Examples:

text-report layout:interleaved options:display-context &

output-to:printer output-options:print-color,wrap-word

text-report layout:patch options:patch-unified &

output-to:"My Report.txt"

TOUCH

Usage:

touch (left->right|right->left)

touch (left|right|all):(now|<timestamp>)

Copies the timestamps from files on one side to the other or sets the timestamps of all files on a specified side to the current system time (now) or a specified timestamp. You must select files before you can touch them.

VERSION-REPORT

Usage:

version-report \

layout:<layout> \

[options:<options>] \

[title:<report title>] \

output-to:(printer|clipboard|<filename>) \

[output-options:<options>] \

[<comparison>]

Generates a Version Compare report of the currently selected files.

· layout controls the report's appearance and can be side-by-side or summary.
· options is optional and is used differently for each layout.
o ignore-unimportant treats differences in unimportant text as matches and is available in all layouts.
o display-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.
· title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

Common Report Arguments

The report commands (data-report, file-report, folder-report, hex-report, mp3-report, pix-report, registry-report, text-report and version-report) must include information on where the report should be sent and may include additional information on the output format.

· title controls the title that appears at the top of the report.
· output-to controls the output target. It can be printer, clipboard or a filename.
· output-options is optional and is used differently for each output target.
o print-color or print-mono color schemes are available for printer output. By default, print-mono is used.
o print-portrait or print-landscape orientations are available for printer output. By default, print-portrait is used.
o wrap-none, wrap-character or wrap-word control whether long lines are wrapped. printer output can use all three options. HTML output can use wrap-none and wrap-word. By default, wrap-none is used.
o html-color, html-mono or html-custom stylesheets are available for clipboard and file outputs. If html-custom is used it should include a URL or path, which will be used as the HTML's external style sheet. By default, html-mono is used.
· <comparison> can either be a session name or a pair of filenames. The file report will use the specified comparison instead of the files that have been selected within the script. When using a saved session, the comparison type must match the report type (e.g., a Data Compare session must use data-report or file-report).

Examples:

data-report layout:interleaved output-to:printer &

output-options:print-color,print-landscape

file-report layout:summary output-to:clipboard &

output-options:wrap-word,html-color

text-report layout:patch options:patch-unified &

output-to:"My Report.txt"


Regular Expression Reference

Regular Expressions are a powerful way to define patterns for searching and matching. Beyond Compare allows you to use regular expressions when searching through text, and when specifying rules for classifying text. The regular expression support in Beyond Compare is a subset of the Perl Compatible Regular Expression (PCRE) syntax.

While Regular Expressions can be a complex topic, there are several excellent resources about them. One such resource is a book called Mastering Regular Expressions. Another excellent resource is Steve Mansour's A Tao of Regular Expressions, a copy of which can be found at:

www.scootersoftware.com/RegEx.html

A regular expression is composed of two types of characters: normal characters and metacharacters. When performing a match, metacharacters take on special meanings, controlling how the match is made and serving as wildcards. Normal characters always match against only themselves. To match against a metacharacter, escape it, by prefixing it with a backslash "\". There are multiple types of metacharacters, each detailed below.

Metacharacters - Escape Sequences

Escape Sequence | Meaning
\xnn | character with the hex code nn
\x{nnnn} | character with the hex code nnnn
\x{F000} | character with a null value
\t | tab (0x09)
\f | form feed (0x0C)
\a | bell (0x07)
\e | escape (0x1B)

Metacharacters - Predefined classes

Predefined character classes match any of a certain subset of characters. The following classes are already defined for you.

Class | Meaning
. | match any character
\w | any alphanumeric character or _
\W | any non-alphanumeric character
\d | any numeric character (0-9)
\D | any non-numeric character
\s | any whitespace (space, tab)

You can also construct your own character classes by surrounding a group of characters in brackets "[]". The predefined classes (except ".") can be used in the brackets, and if a dash "-" appears between two characters, it represents a range. Thus [a-z] would represent all lowercase letters, and [a-zA-Z] would represent both lower and uppercase letters. To include a "-" as part of the class, place it at the beginning or end of the string.

If the first character within the brackets is a caret "^", then the class represents everything except the specified characters. [^a-z] matches on any character that isn't a lower-case alphabetic character.

Metacharacters - Alternatives

By placing an "|" between two groups of items, alternative matches can be represented. a|b will match either a or b. ab|cd will match "ab" or "cd", but not "ac". "|" groups characters from pattern delimiter ("(", "[", or the start of the pattern) to itself and then again to the end of the pattern. Alternatives can be placed within parenthesis "()" to make it obvious what is being matched against, as in a(bc|de)f. Alternatives are matched left to right. bey|beyond will match on bey, even if the string is "beyond".

Metacharacters - Position

The following metacharacters control where the match can occur on a line. Note: \A and \Z match the start and end of text respectively, but since Beyond Compare performs the search on a line by line basis, these have the same effect as ^ and $.

Metacharacter | Meaning
^ | match only at start of line
$ | match only at end of line

Metacharacters - Iterators

Anything in a regular expression can be followed by an iterator metacharacter, which refers to the item before it. There are two kinds of iterators - greedy and non-greedy. Greedy iterators match as many as they can, non-greedy match as few as they can.

Greedy:

Metacharacter | Meaning
* | match zero or more of the preceding character (equivalent to {0,})
+ | match one or more of the preceding character (equivalent to {1,})
? | matches zero or one times (equivalent to {0,1})
{n} | matches exactly n times (equivalent to {n,n})
{n,} | matches n or more times
{n,m} | matches at least n but no more than m times

Non-greedy:

Metacharacter | Meaning
*? | matches zero or more times
+? | matches one or more times
?? | matches zero or one time
{n}? | matches exactly n times
{n,}? | matches at least n times
{n,m}? | matches at least n but no more than m times

Metacharacters - Subexpressions

Parenthesis "()" can also be used to group characters for use with iterators and backreferences (discussed below). (bey){4,5} will match between 4 and 5 instances of "bey". (abc|[0-9])* will match any combination of "abc" and the digits 0 to 9. Eg. "abc5", "679abc" and "abc77abc".

Metacharacters - Back References

Each sequence of characters which is matched within a "()" will be saved as a subexpression, which you can refer to later with \1 to \9, which refer to the subexpressions from left to right. b(.)\1n will match "been" and "boon", but not "bean", "ben" or "beeen".

Modifiers

Modifiers allow changes to the matching behavior from that point on. If the modifier is contained within a subexpression, it affects only that subexpression. Use (?i) and (?-i) to control the case sensitivity of matching.

Examples:

(?i)Beyond Compare | matches both "Beyond Compare" and "beyond compare"
(?i)Beyond (?-i)Compare | matches "Beyond Compare" and "bEyOnD Compare", but not "beyond compare"

See also

Regular Expressions Rename

Sample Regular Expressions


Glossary

Base folder

The top-most folder on either side of a folder view. Base folder names appear in the toolbar path edits above each pane of the comparison.

Child Session

A file session launched from a folder session.

Conflict

In a 3-way merge, a conflict occurs when the same section of text has changes on both left and right sides.

CRC

(Cyclic Redundancy Check) is a numeric representation of the contents of a file. If the CRCs of two files are different, then the contents of those files must be different. If the CRCs match, then it is quite likely that the contents match.

CSV

CSV (Comma Separated Values) is a common file layout for representing row and column data.

File Format

Our term for the collection of settings that characterize a type of file. For example, the Java Source file format describes the Java grammar for syntax highlighting and rules-based comparisons, and stores your tab stop preference for Java source. File formats can also specify conversion routines to be run before and after comparisons.

Filter

A setting that limits what is displayed or processed, "filtering out" unneeded content.

Important text

Text that is important to the comparison.

Line ending style

The pattern of control characters that define the end of each line in a text file. Typically CR+LF in a Windows text file and LF in a Unix text file.

Orphan

Our term for an item that is on one side and not the other in a comparison.

Plug-in

Software accessory that can be 'plugged into' the program for more features.

Regular Expressions

Formulas for matching strings that follow a pattern.

Rules

Our term for the session settings that control how a comparison is performed.

Section

A contiguous range of lines with differences.

Session

Our term for a comparison task, such as comparing folders or files. Each session view is in its own top-level window, or tab on a window.

Skew tolerance

The number of lines Beyond Compare will search forward and backward for a matching section.

Snapshot

A custom Beyond Compare file that contains folder tree information. Like a camera capturing reality at a moment in time, a snapshot file captures the state of a folder so that the user can compare it to the live folder at some later time, and find what has changed.

Thumbnail view

In file comparison windows, the (optional) panel on the left with the color-coded summary of differences.

Timestamp

A timestamp is a file or folder's last modified time.

Tolerance

In Data Compare and Picture Compare, the amount that two cells (or pixels) can differ before being considered an important difference. Differences less than or equal to the tolerance are unimportant differences.

Touch/Touching

The action of setting the timestamp of a file to a specific value.

Unimportant differences

Differences in text that are defined to be unimportant to the comparison. They may include whitespace or character case differences, comments or line numbers.

View

An open session (or the Home view) as it appears as a window or on a tab.

Whitespace

The blank space at the beginning and end of lines and between words. Whitespace is generally made up of any combination of the 'space' and 'tab' characters.

Workspace

The collection of all open sessions, including the size and position of windows and tabs.

Zip archive/zip file

A set of files or folders, compressed into a single archive file. There are different archive formats, but zip is the most common. Beyond Compare supports several different archive formats.


Support, Ordering and License

For the latest version of Beyond Compare and for other news about the program, visit our web site at: www.scootersoftware.com

Technical Support

Please send any comments, suggestions or bug reports to: support@scootersoftware.com

Visit our support forums to share problems and ideas: www.scootersoftware.com/forum

Access our online FAQ and Knowledge Base articles at: www.scootersoftware.com/kb

Customer Support

The single user license fee for Beyond Compare is $30 (US dollars) for the Standard edition and $50 for the Pro edition. The Windows and Linux versions are licensed separately. For current information on multi-user discounts and upgrade policy, please visit our on-line shop at: www.scootersoftware.com/shop

If you need help ordering Beyond Compare, contact us at: sales@scootersoftware.com

For our mailing address and other contact information, visit: www.scootersoftware.com/contact

License Agreement

Our License Agreement allows each licensed user to install and use Beyond Compare on any number of computers. Read the agreement to understand your rights and obligations concerning the use of the software.


3-way Merge Concepts

A merge session helps you combine separate sets of changes into a new version of the data, accommodating both sets of changes.

Consider first a simple 2-sided comparison, where an item is on one side and not the other. The software can't tell if the item was newly added on one side, or if its pair was deleted from the other side:

However, when there is an older copy of the data available there is more information to base merge decisions on. For example, to decide whether an item was added on one side or deleted on the other, we can refer to an older copy of the data:

In this situation, the program can help you quickly and accurately combine independent modifications. This is called a 3-way merge.

However, not all changes can be safely merged without careful review. If the same line has been independently changed on both sides (and the changes are different from each other) the line will be flagged as a conflict requiring manual review.


Attributes

Actions > Attributes

On the Actions menu, the Attributes command modifies various operating system attributes of the selected files and folders.

For Windows file systems, the DOS attributes (Read-only, Hidden or Archive) are modified. You cannot modify the System attribute.

For Unix file systems, the owner and group access permissions are modified.

If a folder is selected, its attributes are modified but not those of its contents. To modify the attributes of folder contents, you need to expand the folder and select the contents.

The checkboxes initially show the current state of the selected items. If a checkbox is unmarked, that attribute is disabled on all the selected files. If a checkbox is marked, that attribute is enabled on all the selected files. If a checkbox is marked and gray, that attribute is only enabled on some of the selected files.

Unmark a checkbox to clear that attribute from all selected files, or check it to set the attribute.


Content Comparisons

At various times, Beyond Compare performs a content comparison on a pair of files to determine if they match.

Content comparison methods

CRC comparison compares CRC values. A CRC (Cyclic Redundancy Check) is a numeric representation of the contents of a file. If the CRCs of two files are different, then the contents of those files must be different. If the CRCs match, then it is likely (but not absolutely certain) that the contents match. When comparing two versions of the same data, you can be reasonably confident that they are exactly the same if their CRCs match.

Binary comparison compares files byte-by-byte.

Rules-based comparison compares files based on their file format associations. It allows you to define unimportant differences, such as changes in whitespace or source code comments. A rules-based comparison can also ignore differences in file encoding or line endings.

Results of content comparisons

CRC and Binary comparisons return one of these results:

Binary same | The files are exactly the same.
Binary differences | At least one byte is different between the files.

Rules-based comparisons have a built-in binary comparison and return one of these results:

Binary same | The files are exactly the same.
Rules-based same | The files have binary differences, such as character encoding, that can be ignored.
Unimportant differences | A rules-based comparison found only unimportant differences.
Important differences | A rules-based comparison found important differences.

When content comparisons are performed

Content comparisons are performed:

· when a Folder Compare or Folder Sync session is loaded, and its session settings call for automatic content comparisons
· explicitly, when the Compare Contents [image] command is used
· when a pair of files is opened in a file session


Copy

Actions > Copy to Right / Copy to Left / Copy to Side

On the Actions menu, the Copy to Right, Copy to Left and Copy to Side commands copy the selected files and folders from one side of the Folder Compare session to the other, overwriting any existing files on the target side.

If a folder is selected, only its filtered contents will be copied (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be copied.

By default, a confirmation dialog appears before the copy. To skip the confirmation when the direction of the copy is unambiguous (Copy to Left, Copy to Right), open the Tools menu, click Options [image], go to the Folder Views > Confirmations page, and disable Confirm file copy.


Copy to Folder

Actions > Copy to Folder

On the Actions menu, the Copy to Folder [image] command copies the selected files and folders to a given folder, optionally with the path intact. You can select items on one side of the Folder Compare view or the other, but not both.

If a folder is selected, only its filtered contents will be copied (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be copied.

When you select Copy to Folder, you can make the target an archive file (such as a zip file). If the archive file does not exist, Beyond Compare will create it for you.

Path Options Example

In this example, three items are selected: The file 10.txt, the folder Q and the file 30.txt.

The pictures below show how the items look in the target folder, using each of the three available path options.

Keep Relative Folder Structure Determines the minimum difference between all of the selected files' paths, and creates that in the target folder. In this example, folders D and P were not selected, but they were created in the target folder in order to keep the same relative structure.

Keep Base Folder Structure Creates the entire path (back to the base folder) in the target folder.

Don't Keep Folder Structure Ignores all path information and copies all selected files and folders into the target folder together. In this example, only the Q folder was created in the target folder, because it was specifically selected.


Delete

Actions > Delete

On the Actions menu, the Delete [image] command deletes the selected files and folders from one or both sides of the comparison.

If a folder is selected, its entire contents are deleted, regardless of file filters or display filters in effect. If an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be deleted.

Enable the Use recycle bin if possible option to move files and folders stored on a local drive to the recycle bin instead of being completely removed. This option is ignored for deletions from network drives, FTP sites and within archive files.


Display Filters

Display filters limit the view to certain comparison results. For example, you can pick Show Differences [image] to hide all the matching files so that you can concentrate on the mismatches. The current display filter choice will be saved whenever you leave a session, unless that session is locked.

Most of the session types have some sort of display filter implementation. The examples below are from a Folder Compare session.

Right-click on the toolbar to pick one of three built-in ways to show display filters on the toolbar: DropDown, Favorites or Toggles. Or, use Tools > Customize Commands [image] to create your own custom layout.

DropDown layout

DropDown is the default style for the toolbar, designed for simplicity and to save space on the toolbar.

The buttons represent Show All [image], Show Differences [image] and Show Same [image]. The drop-down on the middle button lets you pick a different combination display filter.

Favorites layout

The Favorites style includes various filter combinations on the toolbar.

Toggles layout

Toggles represent the individual comparison states.

Select this mode when you want combinations that are not available with the other display filters. For example, the Toggles shown above will display Left Orphans and Right Newer, and nothing else.


Editing a Column Definition

The Column Handling dialog allows you to set options for each comparison column. A subset of this dialog is used to set default handling for all columns.

Specify the Name to be displayed in the header of the comparison column. If none is specified, an automatic one may be used.

Mark the Key checkbox to make data in this column control sorting and alignment. If you have more than one key column, the priority for sorting is granted to the top-most columns in the list.

Mark the Use Default checkbox to use the default column handling as defined for this session.

Select the appropriate Type for the column:

Detected | Automatically determine the column type based on the data in the files.
Boolean | Column values are either "True" or "False", or numeric. Zero is equivalent to False and any non-zero value is True.
Date | Column contains date-time values in any common format. The comparison ignores differences in formatting.
Numeric | Column values are interpreted as real number values. The comparison ignores differences in formatting. For example, 0.00 and 0 are considered the same.
Text | Column contains textual data.

Mark the Unimportant checkbox to indicate that this column is not important to the comparison. (Unimportant differences are colored blue instead of red, or are ignored altogether using the Ignore Unimportant Differences feature.)

Use Date tolerance to allow date-time values in this column to differ by the given amount before being considered an important difference.

Set the Numeric tolerance value to allow numbers to differ by the given amount before being considered an important difference.

The Text important, except for options govern columns that are defined or detected as Text. Mark the Character case (ABC = abc) checkbox if differences in case (i.e., capitalization) are unimportant. Mark the Whitespace checkbox to consider differences in whitespace (the number of blanks before, after or between words) unimportant.


Editing a Grammar Item

Select an existing Element name from the dropdown list or enter your own new name.

To define a simple grammar element:

Select the Basic category. Enter a Text matching string and specify if the string should exactly Match character case and whether the string is a Regular expression.

For an element that is defined by delimiters:

Select the Delimited category. Specify starting and ending delimiters, or a starting delimiter and the Stop at end of line option. Specify if the delimiters should exactly Match character case and whether they are Regular expressions.

An Escape character can be specified that allows the ending delimiter character to be embedded in the element.

For example, the colored literal string in the following code is delimited by apostrophes ('), with backslash (\) as the escape character:

s = 'I can\'t see straight'

To define a list of grammar tokens:

Select the List category and type the tokens into the memo control. Specify if the tokens should exactly Match character case and whether they are Regular expressions.

To define an element as a column range:

Select the Columns category. Specify the starting and ending column numbers, or a starting column and the to end of line option.

To match on repeating page headings in your data:

When comparing report output, a single change can shift all subsequent page headings, causing many additional differences. You can define a page heading grammar item in order to ignore these differences. Select the Lines category. Enter a Text matching string that will match the heading at the top of each page in your data. Typically this would be the Form Feed character. Mark the or line 1 checkbox if the first page doesn't start with the Form Feed character. Set and next xxx lines to the number of lines in the heading. Specify if the match string should exactly Match character case and whether the string is a Regular expression.

To define case-sensitivity:

Enable This element is case sensitive to indicate that changes in character case are important differences during comparison.


Exclude

Actions > Exclude

On the Actions menu, the Exclude command filters out the selected files and folders from the current session. It is a handy alternative to opening the File Filters dialog and entering file/folder exclusions.

If you select one or more files of the same type, the Exclude command will offer to exclude all files of that type.

To remove an exclude, click the file filters icon [image] and remove the entry from the Exclude files (or Exclude folders) list.


Exporting Settings

Tools > Export Settings

You can selectively save your program settings, in order to transfer them to another computer, upgrade to a newer version, or share them with another Beyond Compare user.

To export your settings:

1. On the Tools menu, select Export Settings.
2. Select the type of settings you wish to export:

Program Options include your preferences that you set in the Options dialog.

Program Commands include your preferences that you set in the Customize Commands dialogs.

Program State includes things like window positions and MRU lists.

Sessions include some or all of your named sessions.

File Formats include some or all of your customized file formats.

FTP Profiles include some or all of your FTP settings.

System Info includes information about your computer and your Beyond Compare installation. It is useful for support purposes, to help us debug problems.

3. If you are exporting sessions, file formats, or FTP profiles, click Next to pick the specific named items to be included.
4. Click Finish to export the settings. A settings package (.bcpkg) file will be created.


File Masks

A file mask is a pattern of characters and wildcards used to match folder and file names.

Example: *.* would match any filename. For historical reasons, it even matches files that don't have an extension.

Example: *.html would match any HTML filename.

Wildcards

Wildcards allow a file mask to match multiple folder or file names.

? | Matches any single character.
* | Matches zero or any other amount of characters.
[az] | Matches any single character in the set (a or z).
[a-z] | Matches any single character in the range (from a to z).
[!az] | Matches any single character not in the set (not a and not z).

Example: A? would match A followed by any single character.

Example: A* would match A followed by any amount of characters.

Example: [a-z0-9] would match any number or letter.

Example: [!ac-g] would match any character except for a, c, d, e, f, and g.

Simple file masks

Simple file masks will affect any files or folders whose parent folder is included. The base folder is always included. All folders which contain included files are also included.

To exclude rather than include the specified items, add a minus sign (-) in front of a file mask in the Filters field. In the File Filters dialog, place the file mask in the Exclude field rather than using the minus sign.

f | Include any file named f.
p\ | Include any folder named p.
-f | Exclude any file named f.
-p\ | Exclude any folder named p.

Example: *.pas;*.dfm;*.dpr would include only files with extensions pas, dfm, or dpr.

Example: Source\ would include only folders named Source and their subfolders.

Example: -*.dcu;-*.ddp would exclude files with extensions dcu, or ddp.

Example: -Backup\ would exclude folders named Backup.

Relative file masks

Relative file masks affect files or folders in specific locations.

p\f | f must be in folder p.
.\f | f must be in the base folder.
...\f | f may have zero or more parent folders.

Example: Windows\*.txt would affect any text file in any included folder named Windows.

Example: ...\Windows\*.txt would affect any text file in any folder named Windows.

Example: .\Windows\*.txt would affect any text file in a folder named Windows that is in the base folder.


Find

To locate specific text in a file view, select Find [image] from the Search menu.

Text to find

Enter the text to search for.

Match character case

Match only text with the same uppercase and lowercase characters.

Whole words only

Match on the whole words but not parts of words.

Regular expression

Indicates the search string is a PCRE regular expression. You can use the dropdown button to the right of the search string to insert common regular expression elements. Click the RE Examples button for more info.

Wrap search

When one end of the file is reached, continue searching at the other end.

Search up

Searches backwards, towards the top of the comparison.

Sides

Specify the side(s) of the comparison to search.

Close dialog automatically

Close the dialog immediately after clicking the Find button. Use the Search menu's Find Next [image] and Find Previous [image] commands for finding additional occurrences of the search string.


How to Register

Step 1 - Try It

You can use the program free for 30 days to see if it suits your needs. If you use it beyond 30 days you are obliged to pay the license fee. Please read the License Agreement for details. If you do not register the program, it will stop functioning after 30 days of use (rather than 30 days from installation).

Step 2 - Buy It

The single user license fee for the Standard Edition is US$30, and US$50 for the Pro Edition. We have discounted pricing for multi-user site licenses. For complete instructions and links for on-line ordering, please visit our web site at:

www.scootersoftware.com

Step 3 - Unlock It

Once we receive your order, we email you back with your registration key that unlocks the program. When you receive your registration key, copy it from the email message to the clipboard. Then start up your copy of Beyond Compare and choose Enter Key from the popup window that first appears, or, select Enter Key from the Help menu.

The registration key disables the "nag" screen and removes the 30 day limitation. Your registration key will work with all language versions of Beyond Compare, as well as all subsequent minor version updates.


How to Unlock Beyond Compare

Help > Enter Key

Beyond Compare is distributed in evaluation mode, allowing you to see if it suits your needs. Unless you register, the program will stop running after 30 days of use.

When you purchase a license to Beyond Compare, we send you an unlock key by email. It looks something like this:

--- BEGIN LICENSE KEY ---

CUgJWTb0eQVybpezCYu9CSqDLCtvx6g63hp-hrKHXiNL144KP4FTWHl9I

q4+F5RWwcpzSyX98tlDzSsJm5xvnjuvunNrAG16sjP8Dp4as1gP3M1Pkj

dmDVZXXLlyHoIrMd-Ptl0wpWPU654xu8kc7iYPl5LhOfXJG64V12vJnOm

--- END LICENSE KEY -----

1. From your email program, select the key and copy it to the clipboard. It's ok if you include some of the message before and after the key, but be sure to include the entire key.
2. Then, run Beyond Compare and select the Enter Key option. (Click the Enter Key button on any of the "Evaluation" dialogs, or select Enter Key from the Help menu.)
3. In the "Register Beyond Compare" dialog, your key should automatically appear in the text box. If not, try copying and pasting again.

Unless you are running a portable install of Beyond Compare, you can mark a Register for all users checkbox to store the license key in the program folder, so that all users on this computer will be registered.


Importing Settings

Tools > Import Settings

You can import settings that were previously exported from Beyond Compare 3 or Beyond Compare 2.

To import settings:

1. On the Tools menu, select Import Settings.
2. Select the file containing the settings to import. It can be a Beyond Compare 3 Settings package file (.bcpkg) or XML file. It can also be a Beyond Compare 2 export file (zip or XML file).
3. If the file contains different kinds of settings, mark the checkboxes for the type of settings you wish to import:

Program Options include your preferences that you set in the Options dialog.

Program Commands include your preferences that you set in the Customize Commands dialogs.

Program State includes things like window positions and MRU lists.

Sessions include named sessions.

File Formats include customized file formats.

FTP Profiles include FTP settings.

4. If you are importing sessions, file formats, or FTP profiles, click Next to pick the specific named items to be included.

Warning An item is colored red if its name is the same as one in your stored settings. If you import a red item, it will replace your existing session, file format, or FTP profile!

Mark the Delete all existing sessions checkbox to erase all of your stored sessions before importing those in the file. Likewise, mark Delete all existing file formats or Delete all existing FTP profiles if you wish.

5. Click Finish to import the settings.


License Agreement

Help > About Beyond Compare > License

Your use of Beyond Compare is governed by the following Terms and Conditions:

Acceptance of License Agreement

You should carefully read the following terms and conditions before using Beyond Compare 3 (the "Software"). Unless you have a different license agreement signed by Scooter Software, your use of this software indicates your agreement to these terms and conditions. If you do not accept all of these terms and conditions, you must cease using the Software immediately.

Copyright

Customer acknowledges that the Software, License Key and accompanying user documentation ("Documentation") are copyrighted works owned by Scooter Software and that Customer has no rights in the foregoing except as expressly granted herein.

Free 30-Day Trial

This is not free software. Scooter Software hereby grants you a non-exclusive, non-transferable, limited license to use the Software free of charge for a period of thirty (30) days. Use of the Software beyond the thirty-day (30-day) trial period requires the purchase of a License Key as described below. Use of the Software beyond the thirty-day (30-day) trial period without purchase of a License Key is a violation of U.S. and international copyright laws.

License Key

A unique key that will allow you to use the Software beyond the thirty-day (30-day) free trial period ("License Key") may be purchased from the Scooter Software website, which is currently http://www.scootersoftware.com. A License Key may be purchased for single or multiple users, all users at a named site, or an entire enterprise. A License Key is further categorized by feature set (Standard Edition or Pro Edition), and operating system platform (Windows Platform, Linux Platform, or Dual Platform). A price list on the Scooter Software website details pricing for all license options. Upon purchase of a License Key, Scooter Software hereby grants you a non-exclusive, non-transferable license to use the Software with the applicable feature set on the applicable operating system platform as follows:

Per-User License Key: A Per-User License Key may be purchased for a specific quantity of users. Each user of the total quantity may be either (a) a person who has access to the Software on any number of computers, or (b) a computer on which the Software will be installed for use by any number of persons, one at a time, while physically present at the computer. Each person so licensed must be the Customer, an employee of the Customer, an employee of a Customer's subsidiary company, or a third party consultant retained by the Customer to perform information technology functions (each, a "Third Party") to use the Software solely for Customer's internal business operations and benefit, and for no other purpose whatsoever. Customer shall ensure that such Third Party complies with the terms of this License Agreement and will be responsible for any breach by such Third Party.

Site License Key: An unlimited user, single-location License Key may be used at Customer locations within a 100-mile radius of the site identified in the License Key (the "Site"), by any and all of Customer's employees while personally present at the Site. This license is likewise granted to Customer's employees who typically work at the Site, while performing Customer work at other locations such as client locations or home. Customer shall have the right to sublicense its rights under this License Agreement to third party consultants that it retains to perform information technology functions (each, an "Onsite Consultant"), while personally present at the Site to use the Software solely for Customer's internal business operations and benefit, and for no other purpose whatsoever. Customer shall ensure that such Onsite Consultant complies with the terms of this License Agreement and will be responsible for any breach by such Onsite Consultant.

Enterprise License Key: An enterprise-wide ("Enterprise") License Key may be used world-wide, by any and all of Customer's employees. Customer shall have the right to sublicense its rights under this License Agreement to third party consultants that it retains to perform information technology functions (each, an "Enterprise Consultant"), while personally present at any Customer location to use the Software solely for Customer's internal business operations and benefit, and for no other purpose whatsoever. Customer shall ensure that such Enterprise Consultant complies with the terms of this License Agreement and will be responsible for any breach by such Enterprise Consultant.

You shall be responsible for maintaining the License Key in a safe location and are specifically prohibited from distributing the License Key, intentionally or unintentionally, to any third party not authorized by this License Agreement. Upon loss or distribution of the License Key, Customer shall be required to pay a reinstatement fee at Scooter Software's discretion.

Distribution of the Software

Provided that you do not copy or distribute the License Key, and you include a copy of this License Agreement, you may (a) make copies of the Software; (b) give exact, unmodified copies of the Software to anyone; and (c) distribute the Software in its unmodified form via electronic means. You are specifically prohibited from charging any fees for any such copies or distributions.

Term and Termination

You may continue to use the Software for as long as you comply with the terms and conditions of this License Agreement. Scooter Software may terminate this License Agreement immediately upon notice to you in the event that Scooter Software has reason to believe you have breached this License Agreement. Upon termination, you shall immediately cease all use of the Software, License Key and Documentation and shall not be entitled to a refund of any fees paid.

Warranties

Scooter Software warrants and represents that: (a) it has all right, title and interest in the Software, the right to enter into and provide the license rights granted by this Agreement, and is not party to and will not enter into any agreement, covenant or encumbrance that conflicts with this Agreement; (b) the Software does not, to the best of Scooter Software’s knowledge, infringe upon or violate any patent, copyright, or trade secret or other proprietary right of any third party; (c) the advent of any date or year shall not adversely affect the performance of the Software; and (d) the Software is not contaminated by harmful code (e.g., self-propagating program instructions commonly called viruses, worms or Trojans).

General Disclaimer

Except for the limited warranties set forth herein, THE SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS". TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, SCOOTER SOFTWARE DISCLAIMS ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO IMPLIED WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. ANY LIABILITY OF SCOOTER SOFTWARE WILL BE LIMITED EXCLUSIVELY TO REFUND OF THE PURCHASE PRICE.

Miscellaneous Provisions

The validity and interpretation of this Agreement shall be governed by the laws of the United States of America and the State of Wisconsin. Customer agrees that the state and federal courts located in the State of Wisconsin, Dane County, shall be the appropriate site of venue for actions relating to this Agreement, and hereby consents to the exclusive jurisdiction and venue of such courts. If any provision of this Agreement is declared by a court of competent jurisdiction to be invalid, illegal or unenforceable, such provision or part thereof will be severed from the Agreement and the remaining provisions will remain in full force and effect.


Managing Workspaces

Session > Load Workspace > Manage Workspaces

A workspace is the collection of all open sessions, including the configuration of windows and tabs.

To save your current workspace configuration:

1. From the Session menu, select Save Workspace As.
2. Enter a unique name or select from the dropdown a saved workspace to be replaced.

To reload a saved workspace:

From the Session menu, select Load Workspace and pick a saved workspace from the submenu. This will close all current sessions and reopen the saved configuration.

To delete or rename saved workspaces:

1. From the Session menu, select Load Workspace > Manage Workspaces.
2. Select a saved workspace and press F2 to rename it, or DEL to delete it.

To automatically load or save workspaces:

In the Manage Workspaces dialog, you can specify a workspace name in On startup, load and/or in On exit, save as. These options can also be set in Tools > Options > Startup.

You can also load a workspace by specifying it on the command line.


Move

Actions > Move to Right / Move to Left / Move to Side

On the Actions menu, the Move to Right, Move to Left and Move to Side commands move the selected files and folders from one side of the display to the other, overwriting any existing files on the target side.

If a folder is selected, its entire contents are moved, regardless of file filters or display filters in effect. However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be moved.

By default, a confirmation dialog appears before the move. To skip the confirmation when the direction of the move is unambiguous (Move to Left, Move to Right), open the Tools menu, click Options [image], go to the Folder Views > Confirmations page, and disable Confirm file move.


Move to Folder

Actions > Move to Folder

On the Actions menu, the Move to Folder [image] command moves the selected files and folders to a given folder, optionally with the path intact. You can select items on one side of the Folder Compare view or the other, but not both.

If a folder is selected, only its filtered contents will be moved (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be moved.

When you select Move to Folder, you can make the target an archive file (such as a zip file). If the archive file does not exist, Beyond Compare will create it for you.

Path Options Example

In this example, three items are selected: The file 10.txt, the folder Q and the file 30.txt.

The pictures below show how the items look in the target folder, using each of the three available path options.

Keep Relative Folder Structure Determines the minimum difference between all of the selected files' paths, and creates that in the target folder. In this example, folders D and P were not selected, but they were created in the target folder in order to keep the same relative structure.

Keep Base Folder Structure Creates the entire path (back to the base folder) in the target folder.

Don't Keep Folder Structure Ignores all path information and moves all selected files and folders into the target folder together. In this example, only the Q folder was created in the target folder, because it was specifically selected.


New Folder

Actions > New Folder

On the Actions menu, the New Folder [image] command lets you create a folder at the current position. If you have a file or closed folder selected, the new folder will be created with the same parent folder as the selected item. If you have an opened folder selected, the new folder will be created as a subfolder of the selected one.

If both sides are selected, a new folder will be created on both sides.

To create a new folder to use as a base folder, type the path for the new folder into the left or right edit controls, and press the Enter key. In the warning dialog that appears, click Create.


Rename

Actions > Rename

On the Actions menu, the Rename [image] command renames the selected files and folders.

In the Action subsection, you can select either DOS Compatible or Regular Expressions rename. DOS Compatible expands wildcards using DOS rules. Regular Expressions rename uses Perl-compatible regular expressions.

DOS Rename

To rename files using DOS Compatible Regular Expressions, select files in the Folder Compare view and select Rename [image] from the Actions menu. Select DOS Compatible from the Rename dialog. In the New Mask field, enter the new name.

If multiple files or folders are selected, a base mask is computed which represents the overlap of all the names. An asterisk (*) is used to represent one or more characters, while a question mark (?) is used to represent a single character. Leave these characters alone, but change others to produce unique names for each of the selected files or folders.

Example:

Assume that you've selected the following files to rename:

abc1.txt

abc2.txt

abc3.txt

If you enter "abc?.bak" in the New Name, the files will be renamed to:

abc1.bak

abc2.bak

abc3.bak

Or, enter "xyz?.txt" in the New Name field, and the files will be renamed to:

xyz1.txt

xyz2.txt

xyz3.txt


Reporting Problems

Help > Support

If you have found a problem with Beyond Compare, we would like to hear from you!

From any top-level window, select Support from the Help menu, and follow the instructions to produce a package containing your program and system settings. Attach the settings package to an email including a description of the problem and send it to us at support@scootersoftware.com.

You may want to include a screenshot that illustrates the problem. If you do, follow these steps to make one small enough to email:

1. Press Alt+PrintScreen to place a snapshot of the current window on the clipboard.
2. Open the Microsoft Paint program (Start > Programs > Accessories > Paint) and press Ctrl+V to paste the image.
3. Select the part of the image that you would like to send.
4. Pick Copy To from the Edit menu, change Save as Type to PNG (*.png) or GIF (*.gif), and enter a filename. (If PNG and GIF types are not available, select 256 Color Bitmap and compress the image file with a zip utility.)
5. Attach the image file to your email to us.


Rules vs File Formats

In Beyond Compare, file formats describe the syntax of specific kinds of files by defining elements. File formats are typically picked automatically, based on the filename extension.

A Text Compare session defines which elements are important to the comparison. Notice that the session settings deal with elements in a more abstract manner while the various file formats handle the syntax details.

To change the default importance of an element type:

1. In the Home view's Saved sessions tree, under the Edit session defaults branch, select Text Compare.
2. In the tabbed control to the right of the tree, select the Importance tab.
3. Mark or unmark the appropriate checkboxes.
4. Click Save.

To override importance only in the current Text Compare view:

1. Open Sessions > Session Settings [image] and select the Importance tab.
2. Mark or unmark the appropriate checkboxes.
3. At the bottom of the dialog, choose Use for this view only from the drop-down.
4. Click OK.

To override importance in a Folder Compare session:

5. From the Folder Compare session, open a child Text Compare session.
6. Open Sessions > Session Settings [image] and select the Importance tab.
7. Mark or unmark the appropriate checkboxes.
8. At the bottom of the dialog, choose Use for all files within parent session from the drop-down.
9. Click OK.


Saving Snapshots

Tools > Save Snapshot

To save a snapshot:

1. On the Tools menu, select Save Snapshot [image].
2. Enter the path of the folder tree to be saved. If you access Save Snapshot from a folder session, you have the option of selecting the Left base folder or Right base folder from that session.
3. Mark the appropriate boxes to also include CRCs computed from each file's contents, version data, or expanded archive file contents. These options will make it take longer to create the snapshot, but the results will be more thorough.

CRCs Includes CRC32 calculations in the snapshot.

Exe versions Includes file version, typically found in application files such as .exe, .dll, .ocx, etc.

Archive contents Includes expanded listing of archive file contents in the snapshot.

4. Mark the Empty folders checkbox to include empty folders, or folders whose entire contents have been filtered out.
5. Mark the Symbolic link targets checkbox to include files and folders pointed to by symbolic links.
6. The Items excluded by file filters checkbox is available when Save Snapshot is opened from a folder session. Unmark this checkbox to use the folder session's file filters to limit what's included in the snapshot.
7. Click Start and a dialog will prompt for the filename and location to save the snapshot to.


Synchronize

Actions > Synchronize > Update Right / Update Left / Update Both / Mirror to Right / Mirror to Left

On the Actions menu, the Synchronize submenu has commands that synchronize the current selection.

Update Right | Copies newer and orphan items from left to right.
Update Left | Copies newer and orphan items from right to left.
Update Both | Performs a bidirectional update by copying newer and orphan items from left to right and from right to left.
Mirror to Right | Replaces all different items on right, deletes any right-side orphans, and copies any left-side orphans to the right.
Mirror to Left | Replaces all different items on left, deletes any left-side orphans, and copies any right-side orphans to the left.


Touch

Actions > Touch

On the Actions menu, the Touch [image] command modifies the timestamp (date/time last modified) of the selected files.

If Copy timestamps from other side is selected, then the timestamps of the selected files will be set to match those on the other side. If Set timestamps to --> is used, then any date/time can be selected from the calendar.

The Default selection controls how the calendar is initialized. Current system time will initialize the calendar to the current time. Last touch will recall the timestamp from the last touch operation. The Default selection only initializes the calendar -- you can still change it to any date or time.

If a folder is selected, the Touch command will attempt to change the folder's timestamp but not that of its contents. This command will fail if the operating system does not allow changing folder timestamps.